C
C     SHORTER (than eternity II)
C
C     
C    Tries to find the solution for the Eternity II puzzles
C          
C    Version 0.90 : August 2007
C
C    Armel Le Bail  alb@cristal.org   or   xtal@noos.fr
C
C=====================================================================
C
C   Some definitions :  
C
C   Data read inside of :
C      e2pieces.txt
C      e2hints.txt
C     (see definitions at www.eternity2.net)
C   Parameters for a run are read inside of :
C      config-shorter.txt
C
C   
C   maxp   = maximum number of pieces            =  256
C   maxh   = maximum number of hint pieces       =   10
C   maxdif = maximum number of different figures =   30
C
C   
C
C=====================================================================
C
      program shorter
C
C   maxp = max number of pieces
C
      parameter (maxp=257,maxh=11,maxdif=31)
      integer n0(maxp),np(maxp,4),nz(maxp,4),nx(maxp),ny(maxp)
      integer nph(maxh),nc1(maxh),nc2(maxh),nr(maxh)
      integer mfig(maxdif,maxp),nfig(maxdif)
      integer mmfig(maxdif,maxp),nnfig(maxdif)
      integer mfig0(maxp),mfig02(maxp),mfig0t(maxp)
      integer mmmfig(maxdif,maxp),nnnfig(maxdif)
      integer mmmmfig(maxdif,maxp),nnnnfig(maxdif)
      integer nnfig2(maxp),nnnfig2(maxp)
      integer ipuz(16,16),ni(maxp),nn(maxp),nnr(maxp)
      integer ipuzn(16,16),ipuzns(16,16)
      integer nns(maxp),nxs(maxp),nys(maxp),nnrs(maxp)
      integer ned(4),nned(4),nfi(4),nps(4)
      integer nxfr(4),nyfr(4),nedfr(4),ncheck(4)
      integer nott(maxp)
      integer nis(maxp),nzs(maxp,4)
      integer nxp(maxp,4),nyp(maxp,4),npos(maxp)
      integer npza(maxp,4),nfia(maxp,4)
      integer nfigs(maxdif),mfigs(maxdif,maxp)
      integer nfigss(maxp,maxdif),mfigss(maxp,maxdif,maxp)
      integer ipuznss(maxp,16,16),nsumss(maxp)
      integer niseed(2000000)
      real*8 nmove,nmovemax,nmovemax0
      integer nbm(4),nb1(4),nb2(4),nb3(4),nb4(4),nsa(maxp,4)
      integer nzn(maxp,4),ipnp(maxp),npzss(maxp)
      integer niss(maxp,maxp),nzss(maxp,maxp,4),nnrss(maxp,maxp)
      integer nnss(maxp,maxp),nxss(maxp,maxp),nyss(maxp,maxp)
      integer nbac(maxp),ncount(maxp)
      integer nforce(4),npfr(maxp),nedfr2(maxp)
      integer npfrss(maxp,maxp),nedfrss(maxp,maxp)
      integer iforss(maxp),ifor1ss(maxp)
      integer ipuzns2(16,16)
      integer n1mem(maxp),n2mem(maxp)
      integer nrpm(maxp),newpm1(maxp),newpm2(maxp)
      integer nim1(maxp),nim2(maxp),nbm1(maxp,4),nbm2(maxp,4)
      integer niold(maxp),nzold(maxp,4),ipuzold(16,16),nmem(maxp)
C
C
      CHARACTER*7 DATENOW
      CHARACTER*8 TIMENOW
      character*24  tempo
      character*80  title
      logical qex
C
C
      common/rota/np,nz
      common/back/nxfr,nyfr,nedfr,nnfig,mmfig,ncheck,ifign,nforce,nscar
      common/puz/ni,ipuzn
      common/size/nx1,nx2,nxmax,nx3,nx4,nx5,nx6
C
C
	version='4.04'
C
C Open files 
C
      tempo='e2pieces.txt'
      call open_read1(4,tempo)
      tempo='e2hints.txt'
      call open_read1(5,tempo)
      tempo='config-shorter.txt'
      call open_read1(6,tempo)
      tempo='order.txt'
      call open_read1(25,tempo)
      tempo='eternity.imp'
      inquire(file=tempo,exist=qex)
      if(qex.eq..FALSE.) go to 201
      call filedel(3,tempo)
201   continue
      call open_write1(10,tempo)
      WRITE (10,9000) VERSION
9000  FORMAT(/1x,'=============================================
     -===================='/
     -        1x,'SHORTER version ',a,'  by A. Le Bail - 2007 -
     - alb@cristal.org'/
     -        1x,'=============================================
     -===================='/)
      CALL DATN(DATENOW,TIMENOW)
      CALL CPU_TIME(time_begin)
      write(10,*)
      write(10,*)
C
C   Read configuration of that run in config-shorter.txt
C
      read(6,*)title
      read(6,*)ntyp,icalc0,ntol
      read(6,*)nx1,nx2
C
C     Stop if size larger than 16
C
      if(nx1.gt.16.or.nx2.gt.16)then
        write(10,*)'  Too large size > 16',nx1,nx2
        STOP
      endif
C
      nxmax=nx1*nx2
      nx3=nx1-1
      nx4=nx2-1
      nx6=2*nx1+2*nx2-4
      nx5=nx6-4
      read(6,*)ttime,nmovemax0,iverb
      read(6,*)prop,damp0
      read(6,*)nch,nscar
      read(6,*)l2,c2
      read(6,*)l3,c3
      read(6,*)limref
      read(6,*)ncou,nbi
      write(10,*)title
      write(10,*)' Puzzle data and calc. type   ',ntyp,icalc0
      write(10,*)' Tolerance on error           ',ntol
      write(10,*)' Size nx*ny                   ',nx1,nx2
      write(10,*)' Total CPU time asked (hours) ',ttime
      write(10,*)' Max number of moves          ',nmovemax0
      write(10,*)' Verbosity                    ',iverb
      write(10,*)' Proportions of perm and rot  ',prop
      write(10,*)' Damping factor               ',damp0
      write(10,*)' nch (piece at 1,1)           ',nch
      write(10,*)' nscar                        ',nscar
      write(10,*)' level2 parameter             ',l2,c2
      write(10,*)' level3 parameter             ',l3,c3
      write(10,*)' limref                       ',limref
      write(10,*)' ncou                         ',ncou
      write(10,*)' nbi                          ',nbi
C 
C  Total time now in seconds
C
      ttime=ttime*3600.
C
C   title = a title for the job 
C   ntyp = kind of data inside of the e2pieces.txt file
C           if ntyp = 1
C  99    read(4,*,ERR=100)np(ip,1),np(ip,2),np(ip,3),np(ip,4)
C      by default, the order of the piece is 1 to nx1*nx2
C           if ntyp = 2
C  99    read(4,*,ERR=100)n0(ip),np(ip,1),np(ip,2),np(ip,3),np(ip,4)
C      the order number of the piece is first read
C    nx1,nx2  =  size of the puzlle 
C              16*16 or 6*6 or 6*12, etc
C 
C   icalc0 = code telling the kind of calculation :
C           0 : piece after piece following order.txt
C           n >=1 : pure permutations, then nmovemax applies
C                   n <10 couples of permutations are realized
C                         before testing the gain on the edge number
C   ntol = number of false edge tolerated to accept a move
C   time = CPU time in hours
C           however, checking for time is made after
C           a multiple of 1000 independent Monte Carlo tests
C           so that the total time may be up to one
C           minute longer than "time"...
C   nmovemax0 = number of attempt to place a piece
C                inside of a test
C   iverb : verbosity
C       if = 0 : minimum
C       if = 1 : medium
C       if = 2 : maximum
C   prop  :   Proportions of permutations and rotations
C   damp0 :   Damping factor             
C   nch = code for using the corner pieces as hint pieces
C       if = 0 : no use
C       if = 1 : piece 1 at (1,1)
C       if = 2 : piece 2 at (1,1)
C       if = 3 : piece 3 at (1,1)
C       if = 4 : piece 4 at (1,1)
C  l2, c2 : if l2 pieces are not attained before c2 moves
C                        then restart
C  l3, c3 : if l3 pieces are not attained before c3 moves
C                        then restart
C
C
C
C   Read data in e2pieces.txt
C
      ip=1
99    if(ntyp.eq.1)then
      read(4,*,ERR=100)np(ip,1),np(ip,2),np(ip,3),np(ip,4)
      n0(ip)=ip
      ip=ip+1
      go to 99
      else
      read(4,*,ERR=100)n0(ip),np(ip,1),np(ip,2),np(ip,3),np(ip,4)
      ip=ip+1
      go to 99
      endif
100   continue
      ip=ip-1
C
C   Determine which puzzle : 256, or 72 or 36 or 16 etc ??
C
      npuz=ip
      write(*,10)npuz
      write(10,10)npuz
10    format(/' Searching for the puzzle ',I4/)
C
C     Stop if not the correct puzzle
C
      if(npuz.ne.nxmax)then
        write(10,*)'npuz different from nx*ny',npuz,nxmax
        STOP
      endif
C
C   Write list of pieces with figure numbers
C
C      write(10,8)
C      do i=1,npuz
C      write(10,9)i,(np(i,k),k=1,4)
C      enddo
8     format(/' Piece N     fig1   fig2   fig3   fig4'/)
9     format(5x,I4,4X,4(I4,3x))
C
C   Read data in e2hints.txt
C
      read(5,*)nh
      do i=1,nh
      read (5,*) nph(i),nc1(i),nc2(i),nr(i)
      enddo
C
C   Details
C
C   nph = number of the hint piece
C   nc1 = x coordinate of the hint piece
C   nc2 = y coordinate of the hint piece
C   nr = rotation of the hint piece
C
C
C
C   Read order to fill the puzzle in order.txt
C
      read(25,*)npi
      do i=1,npi
      read(25,*)jj,npos(i)
      do j=1,npos(i)
      read(25,*)nxp(i,j),nyp(i,j),nfia(i,j)
      enddo
      enddo
C
C   npi  = number of pieces of the not-random walk
C   nxp(i), nyp(i) = coordinates i,j on the puzzle of a piece i
C                    in principle already placed, then one of its
C                    edge will be used for selecting the next
C                    piece
C   npos(i) = number of possibilities for placing the piece i+1
C   npza(i,j) = piece number i for possibility npos(j)
C   nfia(i,j) = number of the edge of piece npza which will
C               be used for placing the piece i+1
C
C
C
C   Initialization
C
C
C   Analysis of the number of different figures
C
      ifig=1
      do i=1,ip
      do j=1,4
      if(np(i,j).gt.ifig)ifig=np(i,j)
      enddo
      enddo
C
C   Taking account of piece numbered 0 
C
      ifig=ifig+1
      write(*,11)ifig
      write(10,11)ifig
11    format(/' Number of different figures + corners ',I4/)
C   
C   Finding those being similar by one figure
C
C   the four corners are treated apart
C
      ip0=5
C
      do 200 k=1,ifig
      l=k-1
      nfig(k)=0
C
C  exclude the border pieces outside of the first list 
C
      if(k.gt.1)then
         ip0=nx1*2+nx2*2-3
      endif
C
      do 199 i=ip0,ip
      do 198 j=1,4
      if(np(i,j).eq.l)then
      nfig(k)=nfig(k)+1
      mfig(k,nfig(k))=i
      go to 199
      endif
198   continue
199   continue
200   continue
C
C   put the 4 corners at ifig+1
C
      k=ifig+1
      do 999 j=1,4
      mfig(k,j)=j
999   continue
      nfig(k)=4
C
C   Print the results of this analysis
C
C      do k=1,ifig
C      l=k-1
C      write(10,12)nfig(k),l
C      do j=1,nfig(k)
C      write(10,13)mfig(k,j),(np(mfig(k,j),jj),jj=1,4)
C      enddo
C      enddo
12    format(/I4,' Pieces showing figure ',I4/)
13    format(5x,8I4)
C      k=ifig+1
C      write(10,14)nfig(k)
C      do j=1,4
C      write(10,13)mfig(k,j),(np(mfig(k,j),jj),jj=1,4)
C      enddo
14    format(/I4,' Pieces for corners '/)
C
C   Defining the puzzle
C      first initialize all places as being inoccupied (with 0)
C
      do i=1,nx1
      do j=1,nx2
      ipuz(i,j)=0
      enddo
      enddo
C
C   Installing the hint pieces, with rotation if any
C  
      write(10,18)
      npz=0
      do i=1,nh
      npz=npz+1
      write(10,18)npz
      ipuz(nc1(i),nc2(i))=nph(i)
      ni(nph(i))=npz
      nx(npz)=nc1(i)
      ny(npz)=nc2(i)
      ih=nph(i)
      ir=nr(i)
      call rot(ih,npz,ir)
C      write(10,19)nn(npz),nx(npz),ny(npz),nnr(npz)
      enddo
18    format(//' hint piece N ',i4)
19    format(5i5)
C
C   npz = number of pieces already placed
C   ipuz(x,y) contains the piece number
C   ni contains npz for the piece number nn
C   nr = rotation for hint piece nph
C   nn(npz) = piece number in order being placed on the puzzle
C   nx(npz) = x coordinate of piece npz placed
C   ny(npz) = y coordinate of piece npz placed
C   nnr(npz) = rotation of piece npz placed
C      nn,nx,ny,nnr are to be placed in the final result
C   np(ip,4)  = the four figures of all starting pieces (never change)
C   nz(npz,4) = the four figures for piece npz installed on the puzzle
C        after rotation, etc 
C
C    pieces : read(4,*,ERR=100)np(ip,1),np(ip,2),np(ip,3),np(ip,4)
C    hints : read (5,*) nph(i),nc1(i),nc2(i),nr(i)
C
C   Using or not the corner pieces as hint pieces
C               according to the user decision (nch)
C
C    nch = code for using the corner pieces as hint pieces
C       if = 0 : no use
C       if = 1 : piece 1 at (1,1)
C       if = 2 : piece 2 at (1,1)
C       if = 3 : piece 3 at (1,1)
C       if = 4 : piece 4 at (1,1)
C       if = 5 : pieces 1 to 4 randomly at (1,1)
C
      if(nch.eq.0.or.nch.eq.5)go to 401
      do jj=1,4
      if(nch.eq.jj)then
      npz=npz+1
      write(10,18)npz
      ipuz(1,1)=nch
      ni(nch)=npz
      nx(npz)=1
      ny(npz)=1
C
C Find the rotation ir by locating where are the 0,0 figures
C
      do i=1,4
      if(np(nch,i).eq.0)then
      j=i+1
      if(j.eq.5)j=1
      if(np(nch,j).eq.0)go to 400
      endif
      enddo
C
400   continue
      if(i.eq.4.and.j.eq.1)ir=0
      if(i.eq.1.and.j.eq.2)ir=3
      if(i.eq.2.and.j.eq.3)ir=2
      if(i.eq.3.and.j.eq.4)ir=1
      ih=nch
      call rot(ih,npz,ir)
C      write(10,19)nn(npz),nx(npz),ny(npz),nnr(npz)
      write(10,19)(np(nch,j),j=1,4),ir
      write(10,19)(nz(npz,j),j=1,4)
      go to 401
      endif
      enddo
401   continue
C
C   Other initializations
C
      npz0=npz
C
C     nad is a number of edges to add at level 2
C     depending on the number of hint pieces
C         nad = 0 if only first central hint
C         nad = 2 if one more piece at level 3
C         nad = 4 if 3 pieces at level 3
C
C
      iseed=0
      call init(iseed)
C
C   nsumax is the number of edges satisfied
C             it should be 480 for winning...  Aaaarrrggghhh...
C   nsumax2 = nsumax + the number of edges satisfied
C                      by pieces imperfecly matching... 
C
      nsumax=0
      nsumax2=0
      nsumax3=0
      nsum2=0
C
C
C
C
C   BIG LOOP - BIG LOOP  - BIG LOOP  - BIG LOOP  - BIG LOOP 
C   BIG LOOP - BIG LOOP  - BIG LOOP  - BIG LOOP  - BIG LOOP 
C   BIG LOOP - BIG LOOP  - BIG LOOP  - BIG LOOP  - BIG LOOP 
C   BIG LOOP - BIG LOOP  - BIG LOOP  - BIG LOOP  - BIG LOOP 
C   BIG LOOP - BIG LOOP  - BIG LOOP  - BIG LOOP  - BIG LOOP 
C   BIG LOOP - BIG LOOP  - BIG LOOP  - BIG LOOP  - BIG LOOP 
C
C
      iii=0
5001  continue
      nout=0
      iii=iii+1
      nsumax=0
      nsumax2=0
      bestm=0.
      do i=1,4
      nforce(i)=0
      enddo
      ifor=0
      ifor1=1
C
C   memorize iseed
C     and if the same value is detected, reinit
C
        if(iii.gt.2000000)then
        write(*,*)'more than 2000000 tests - STOP'
        write(10,*)'more than 2000000 tests - STOP'
        STOP
        endif
        niseed(iii)=iseed
        if(iii.ge.2)then
        do jjj=1,iii-1
        if(iseed.eq.niseed(jjj))then
	  write(10,*)'reinit iseed at test',iii
	  write(*,*)'reinit iseed at test',iii
	  call init(iseed)
        endif
	  enddo
        endif
C
C
C     check for time there...
C
C
      ichtime=mod(iii,10)
      if(ichtime.eq.0)then
        CALL CPU_TIME(time_end)
        totaltime=time_end-time_begin
        if(totaltime.gt.ttime)go to 7002
      endif
C
C
C      if(iii.eq.2)go to 5012
C
C
C
C   Restart at npz0 = only the original hint pieces
C                     + one corner if decided by the user...
C
C
      npz=npz0
      nsum=0
      nmove=0.
      nmovemax=nmovemax0
      do i=1,nx1
      do j=1,nx2
      ipuzn(i,j)=ipuz(i,j)
      enddo
      enddo
C
C       if nch = 5 : pieces 1 to 4 randomly at (1,1)
C
      if(nch.eq.5)then
C
C   random selection
C
      npr=int(4.*randi(iseed))+1
      if(npr.gt.4)npr=4
C
      npz=npz+1
C      write(10,18)npz
      ipuzn(1,1)=npr
      ni(npr)=npz
      nx(npz)=1
      ny(npz)=1
C
C Find the rotation ir by finding where are the 0,0 figures
C
      do i=1,4
      if(np(npr,i).eq.0)then
      j=i+1
      if(j.eq.5)j=1
      if(np(npr,j).eq.0)go to 402
      endif
      enddo
C
402   continue
      if(i.eq.4.and.j.eq.1)ir=0
      if(i.eq.1.and.j.eq.2)ir=3
      if(i.eq.2.and.j.eq.3)ir=2
      if(i.eq.3.and.j.eq.4)ir=1
      ih=npr
      call rot(ih,npz,ir)
      endif
C
C   Reinit the complete series of figures, including corners
C
      ifign=ifig+1
      do i=1,ifign
      nnfig(i)=nfig(i)
      do j=1,nfig(i)
      mmfig(i,j)=mfig(i,j)
      enddo
      enddo
C
C   Remove the pieces already placed from the lists nnfig and mmfig
C
      do k=1,npz
C
      do i=1,ifign
      nnnfig(i)=0
      do j=1,nnfig(i)
      if(mmfig(i,j).ne.ipuzn(nx(k),ny(k)))then
      nnnfig(i)=nnnfig(i)+1
      mmmfig(i,nnnfig(i))=mmfig(i,j)
      endif
      enddo
      enddo
C
      do i=1,ifign
      nnfig(i)=nnnfig(i)
      enddo
      do i=1,ifign
      do j=1,nnfig(i)
      mmfig(i,j)=mmmfig(i,j)
      enddo
      enddo
C
      enddo
C
C  Escape if only permutations
C
      if(icalc0.gt.0)go to 7003
C
C   Start the non-random walk (spiral or other) read into
C                       order.txt  by :
C
C
C   npi  = number of pieces of the not-random walk
C   nxp(i), nyp(i) = coordinates i,j on the puzzle of a piece i
C                    in principle already placed, then one of its
C                    edge will be used for selecting the next
C                    piece
C   npos(i) = number of possibilities for placing the piece i+1
C   npza(i,j) = piece number i for possibility npos(j)
C   nfia(i,j) = number of the edge of piece npza which will
C               be used for placing the piece i+1
C
C  Origin
C
      npr=0
      level=1
      iplus=1
      iloop=0
      do i=1,nxmax
      nbac(i)=0
      ncount(i)=0
      enddo
C
C   Sub-loop there  Sub-loop there  Sub-loop there
C   Sub-loop there  Sub-loop there  Sub-loop there
C   Sub-loop there  Sub-loop there  Sub-loop there
C   Sub-loop there  Sub-loop there  Sub-loop there
C
498    continue
C
C    reinit a few things
C
      if(iplus.eq.0)then
C      write(10,*)'backtrack at: npr, nbac',npr,nbac(npr)
C      write(*,*)'backtrack at: npr,nbac',npr,nbac(npr)
      if(npr.le.0)then
         nout=2
         go to 7002
      endif
      npz=npzss(npr)
      nsum=nsumss(npr)
C
C   reinit the fig state
C
      do i=1,ifign
      nnfig(i)=nfigss(npr,i)
      do j=1,nnfig(i)
      mmfig(i,j)=mfigss(npr,i,j)
      enddo
      enddo
C
C  reinit ipuzn
C
      do i=1,nx1
      do j=1,nx2
      ipuzn(i,j)=ipuznss(npr,i,j)
      enddo
      enddo
C
C  reinit nz, ni, etc
C
      do i=1,nxmax
      ni(i)=niss(npr,i)
      enddo
      do i=1,npz
      nx(i)=nxss(npr,i)
      ny(i)=nyss(npr,i)
      do j=1,4
      nz(i,j)=nzss(npr,i,j)
      enddo
      enddo
C
C  reinit the forced pieces system
C
      ifor=iforss(npr)
      ifor1=ifor1ss(npr)
      do i=1,ifor
      npfr(i)=npfrss(npr,i)
      nedfr2(i)=nedfrss(npr,i)
      enddo
C
C
      npr=npr+1
      if(npr.lt.1)write(*,*)'0 npr < 1',npr
      if(npr.gt.nxmax)write(*,*)'0 npr > nxmax',npr
      go to 497
C
      endif
C
C  Sub-loop there  Sub-loop there  Sub-loop there
C  Sub-loop there  Sub-loop there  Sub-loop there
C  Sub-loop there  Sub-loop there  Sub-loop there
C
C  Try to place the next piece :
C
C
C
C
499   continue
C
C
C    
C
C
      nmove=nmove+1.
      if(nmove.ge.nmovemax)then
           nout=3
           go to 7002
      endif
      if(npr.gt.npi)then
         nout=4
         go to 7002
      endif
C
C   iplus = 1 if a new piece was successfully placed
C             then go to npr+1
C   otherwise, iplus = 0 : go back to the npr-3 or less...
C
      if(iplus.eq.1)then
C
C  memorize all details
C
      if(npr.ne.0)then
      npzss(npr)=npz
      nsumss(npr)=nsum
      do i=1,nxmax
      niss(npr,i)=ni(i)
      enddo
      do i=1,npz
      nxss(npr,i)=nx(i)
      nyss(npr,i)=ny(i)
      do j=1,4
      nzss(npr,i,j)=nz(i,j)
      enddo
      enddo
C
C   memorize the fig state
C
      do i=1,ifign
      nfigss(npr,i)=nnfig(i)
      do j=1,nfigss(npr,i)
      mfigss(npr,i,j)=mmfig(i,j)
      enddo
      enddo
C
C  memorize ipuzn
C
      do i=1,nx1
      do j=1,nx2
      ipuznss(npr,i,j)=ipuzn(i,j)
      enddo
      enddo
C
C  memorize the forced pieces system
C
      iforss(npr)=ifor
      ifor1ss(npr)=ifor1
      do i=1,ifor
      npfrss(npr,i)=npfr(i)
      nedfrss(npr,i)=nedfr2(i)
      enddo
C
      endif
C
C  go ahead
C
      npr=npr+1
C
CCCCCCCCCCCCCCCCC      nbac(npr)=0
C
C  else
C
      else
C
C  go back
C
C      if(npzs.lt.l2.and.nmove.gt.c2)then
C      write(*,120)nsumax,npzs,iii,bestm
C      write(10,120)nsumax,npzs,iii,bestm
C      go to 5001
C      endif
C      if(npzs.lt.l3.and.nmove.gt.c3)then
C      write(*,120)nsumax,npzs,iii,bestm
C      write(10,120)nsumax,npzs,iii,bestm
C      go to 5001
C      endif
      iloop=iloop+1
C       if(nbac(npr).gt.1)write(*,*)'nbac,npr',nbac(npr),npr
C       if(nbac(npr).gt.1)write(10,*)'nbac,npr',nbac(npr),npr
      ncount(npr)=ncount(npr)+1
      if(ncount(npr).eq.1)nbac(npr)=nbac(npr)+nbi
      if(ncount(npr).gt.ncou)nbac(npr)=nbac(npr)+1
      npr0=npr
      npr=npr-nbac(npr)
      if(npr.lt.1)then
C       write(10,*)'Back from npr0 to npr',npr0,npr
C           nout=5
C           go to 7002
         npr=1
      endif
C      do i=1,npr0-1
      do i=npr,npr0-1
C      do i=npr-1,npr0-1
      nbac(i)=0
      enddo
      go to 498
C
      endif
C
C  reinitiate iplus
C
497   iplus=0
C
C
C
C  Try to place the next piece
C
C
C  Forced piece ?
C
      if(ifor1.le.ifor.and.ifor.ne.0)go to 495
C
C    anymore edge to use ???
C
493   continue
C
      if(npr.lt.1)write(*,*)'1 npr < 1',npr
      if(npr.gt.nxmax)write(*,*)'1 npr > nxmax',npr
      if(npr.lt.1)write(10,*)'1 npr < 1',npr
      if(npr.gt.nxmax)write(10,*)'1 npr > nxmax',npr
      ipos=0
      do i=1,npos(npr)
      newp=ipuzn(nxp(npr,i),nyp(npr,i))
      if(newp.ne.0)then
      ipos=i
      go to 452
	endif
      enddo
C
C  If ipos = 0, then jump to the next piece
C
452   continue
C
      if(ipos.eq.0)then
C        npr=npr+1
       go to 499
      endif
C
C
C   Position and numbers of the piece 
C               used for selecting the next piece      
C
      nxx=nxp(npr,ipos)
      nyy=nyp(npr,ipos)
C
C   ned = edge number of that opiece to be satisfied
C
      ned(1)=nfia(npr,ipos)
C
C
C      write(10,*)'npr,nxx,nyy,ned(1)',npr,nxx,nyy,ned(1)
C      write(*,*)'npr,nxx,nyy,ned(1)',npr,nxx,nyy,ned(1)
C
C
C   the figure of this piece is defined
C
      nfi(1)=nz(ni(newp),ned(1))
C
C
C  jump if no forced piece
C
C
      go to 494
C
C  one forced piece
C
495   continue
C
C   Position and numbers of the forced piece       
C
      nprs=npfr(ifor1)     ! npz
      nxx=nx(nprs)
      nyy=ny(nprs)
C
C   ned = edge number
C
      ned(1)=nedfr2(ifor1)
C
C
C      write(10,*)'ifor1,nxx,nyy,ned(1)',ifor1,nxx,nyy,ned(1)
C      write(*,*)'ifor1,nxx,nyy,ned(1)',ifor1,nxx,nyy,ned(1)
C
C   the figure of this piece is defined
C
      nfi(1)=nz(nprs,ned(1))
C
      ifor1=ifor1+1
      npr=npr-1
C
494   continue
C
C  end of forced piece
C
C
C   nnfi = number of figures to satisfy 
C        at least one, then see if more
C
      nnfi=1
C   
C
      if(nfi(1).eq.0)then
      write(10,*)'nfi(1).eq.0...'
      write(*,*)'nfi(1).eq.0...'
      write(10,*)'npr =',npr
      write(10,*)'npr,nz(npr,1 to 4)'
      do i=1,npr
      write(10,888)i,(nz(i,k),k=1,4)
      enddo
      write(10,*)
      write(10,*)'ned(1) = ',ned(1)
888   format(2x,i4,2x,4i4,4x,4i4)
      go to 499
      endif
C
C   Determine the coordinates (nnxx,nnyy) of the new piece
C         neighbouring that selected figure of the (nxx,nyy) piece
C   And verify if this place is already occupied...
C
C
      if(ned(1).eq.1.and.ipuzn(nxx,nyy-1).eq.0)then
      nnxx=nxx
      nnyy=nyy-1
      go to 500
      endif
      if(ned(1).eq.2.and.ipuzn(nxx+1,nyy).eq.0)then
      nnxx=nxx+1
      nnyy=nyy
      go to 500
      endif
      if(ned(1).eq.3.and.ipuzn(nxx,nyy+1).eq.0)then
      nnxx=nxx
      nnyy=nyy+1
      go to 500
      endif
      if(ned(1).eq.4.and.ipuzn(nxx-1,nyy).eq.0)then
      nnxx=nxx-1
      nnyy=nyy
      go to 500
      endif
C      write(*,*)'problem ! nxx,nyy,ned(1)',nxx,nyy,ned(1)
C      write(10,*)'problem ! nxx,nyy,ned(1)',nxx,nyy,ned(1)
      npr=npr+1
      go to 493
C
C  Or this means that this is the end ???
C        then go to finishing if ed > 400 (???)
C        (trying to place imperfectly the last pieces)
C
500   continue
C
C   initialize the number of free next neighbours to check 
C             by further backtracking
C
      nnfr=0
C
C
C  OK, we have a new piece to place now...
C        see if it is at a corner, a border, or else ?
C        then see if there are other neighbours ?
C
C
C  Is the place (nnxx,nnyy) for the new piece a border or a corner ?
C     corners are 1,1  1,nx2  nx1,1  or nx1,nx2    :   nb=2
C     borders are 1,2 to 1,nx4                  :   nb=1
C                2,1 to nx3,1                         "
C                2,nx2 to nx3,nx2                       "
C                nx1,2 to nx1,nx4                       "
C     outside borders                          :   nb=0
C
      if(nnxx.eq.1.or.nnxx.eq.nx1.or.nnyy.eq.1.or.nnyy.eq.nx2)then
C
C  Yes, the new piece will be on the border or at a corner
C
C
C  Are there other close pieces already ??
C
C     Case with the new piece to be placed at (1,1)
C
      if(nnxx.eq.1.and.nnyy.eq.1)then
      nb=2
C  check for another neighbour
      if(ned(1).eq.1)then
        if(ipuzn(2,1).ne.0)then
        nnfi=4
        nps(2)=ni(ipuzn(2,1))
        nfi(2)=nz(nps(2),4)
        ned(2)=4
        nfi(3)=0
        nfi(4)=0
        ned(3)=3
        ned(4)=2
        go to 3000
        else
        nnfi=3
        nfi(2)=0
        nfi(3)=0
        ned(2)=3
        ned(3)=2
        nnfr=nnfr+1
        nxfr(nnfr)=2
        nyfr(nnfr)=1
        nedfr(nnfr)=2
        go to 3000
        endif
      endif
C
      if(ned(1).eq.4)then
        if(ipuzn(1,2).ne.0)then
        nnfi=4
        nps(2)=ni(ipuzn(1,2))
        nfi(2)=nz(nps(2),1)
        ned(2)=1
        nfi(3)=0
        nfi(4)=0
        ned(3)=3
        ned(4)=2
        go to 3000
        else
        nnfi=3
        nfi(2)=0
        nfi(3)=0
        ned(2)=3
        ned(3)=2
        nnfr=nnfr+1
        nxfr(nnfr)=1
        nyfr(nnfr)=2
        nedfr(nnfr)=3
        go to 3000
        endif
      endif
C
      endif
C
C  End of case (1,1)
C
C
C     Case with the new piece to be placed at (nx1,1)
C
      if(nnxx.eq.nx1.and.nnyy.eq.1)then
      nb=2
      if(ned(1).eq.1)then
        if(ipuzn(nx3,1).ne.0)then
        nnfi=4
        nps(2)=ni(ipuzn(nx3,1))
        nfi(2)=nz(nps(2),2)
        ned(2)=2
        nfi(3)=0
        nfi(4)=0
        ned(3)=3
        ned(4)=4
        go to 3000
        else
        nnfi=3
        nfi(2)=0
        nfi(3)=0
        ned(2)=3
        ned(3)=4
        nnfr=nnfr+1
        nxfr(nnfr)=nx3
        nyfr(nnfr)=1
        nedfr(nnfr)=4
        go to 3000
        endif
      endif
C
      if(ned(1).eq.2)then
        if(ipuzn(nx1,2).ne.0)then
        nnfi=4
        nps(2)=ni(ipuzn(nx1,2))
        nfi(2)=nz(nps(2),1)
        ned(2)=1
        nfi(3)=0
        nfi(4)=0
        ned(3)=3
        ned(4)=4
        go to 3000
        else
        nnfi=3
        nfi(2)=0
        nfi(3)=0
        ned(2)=3
        ned(3)=4
        nnfr=nnfr+1
        nxfr(nnfr)=nx1
        nyfr(nnfr)=2
        nedfr(nnfr)=3
        go to 3000
        endif
      endif
C
      endif
C
C  End of case (nx1,1)
C
C
C     Case with the new piece to be placed at (1,nx2)
C
      if(nnxx.eq.1.and.nnyy.eq.nx2)then
      nb=2
      if(ned(1).eq.3)then
        if(ipuzn(2,nx2).ne.0)then
        nnfi=4
        nps(2)=ni(ipuzn(2,nx2))
        nfi(2)=nz(nps(2),4)
        ned(2)=4
        nfi(3)=0
        nfi(4)=0
        ned(3)=2
        ned(4)=1
        go to 3000
        else
        nnfi=3
        nfi(2)=0
        nfi(3)=0
        ned(2)=2
        ned(3)=1
        nnfr=nnfr+1
        nxfr(nnfr)=2
        nyfr(nnfr)=nx2
        nedfr(nnfr)=2
        go to 3000
        endif
      endif
C
      if(ned(1).eq.4)then
        if(ipuzn(1,nx4).ne.0)then
        nnfi=4
        nps(2)=ni(ipuzn(1,nx4))
        nfi(2)=nz(nps(2),3)
        ned(2)=3
        nfi(3)=0
        nfi(4)=0
        ned(3)=2
        ned(4)=1
        go to 3000
        else
        nnfi=3
        nfi(2)=0
        nfi(3)=0
        ned(2)=2
        ned(3)=1
        nnfr=nnfr+1
        nxfr(nnfr)=1
        nyfr(nnfr)=nx4
        nedfr(nnfr)=1
        go to 3000
        endif
      endif
C
      endif
C
C  End of case (1,nx2)
C
C
C     Case with the new piece to be placed at (nx1,nx2)
C
      if(nnxx.eq.nx1.and.nnyy.eq.nx2)then
      nb=2
      if(ned(1).eq.2)then
        if(ipuzn(nx1,nx4).ne.0)then
        nnfi=4
        nps(2)=ni(ipuzn(nx1,nx4))
        nfi(2)=nz(nps(2),3)
        ned(2)=3
        nfi(3)=0
        nfi(4)=0
        ned(3)=4
        ned(4)=1
        go to 3000
        else
        nnfi=3
        nfi(2)=0
        nfi(3)=0
        ned(2)=4
        ned(3)=1
        nnfr=nnfr+1
        nxfr(nnfr)=nx1
        nyfr(nnfr)=nx4
        nedfr(nnfr)=1
        go to 3000
        endif
      endif
C
      if(ned(1).eq.3)then
        if(ipuzn(nx3,nx2).ne.0)then
        nnfi=4
        nps(2)=ni(ipuzn(nx3,nx2))
        nfi(2)=nz(nps(2),2)
        ned(2)=2
        nfi(3)=0
        nfi(4)=0
        ned(3)=4
        ned(4)=1
        go to 3000
        else
        nnfi=3
        nfi(2)=0
        nfi(3)=0
        ned(2)=4
        ned(3)=1
        nnfr=nnfr+1
        nxfr(nnfr)=nx3
        nyfr(nnfr)=nx2
        nedfr(nnfr)=4
        go to 3000
        endif
      endif
C
      endif
C
C  End of case (nx1,nx2)
C
C
C  Now, see the borders...
C
C
C     Case with the new piece to be placed at border (x=1,y)
C
      if(nnxx.eq.1)then
      nb=1
      if(ned(1).eq.1)then
        if(ipuzn(1,nnyy-1).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(1,nnyy-1))
        nfi(nnfi)=nz(nps(nnfi),3)
        ned(nnfi)=3
        else
        nnfr=nnfr+1
        nxfr(nnfr)=1
        nyfr(nnfr)=nnyy-1
        nedfr(nnfr)=1
        endif
        if(ipuzn(2,nnyy).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(2,nnyy))
        nfi(nnfi)=nz(nps(nnfi),4)
        ned(nnfi)=4
        else
        nnfr=nnfr+1
        nxfr(nnfr)=2
        nyfr(nnfr)=nnyy
        nedfr(nnfr)=2
        endif
        nnfi=nnfi+1
        nfi(nnfi)=0
        ned(nnfi)=2
        go to 3000
      endif
C
      if(ned(1).eq.3)then
        if(ipuzn(1,nnyy+1).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(1,nnyy+1))
        nfi(nnfi)=nz(nps(nnfi),1)
        ned(nnfi)=1
        else
        nnfr=nnfr+1
        nxfr(nnfr)=1
        nyfr(nnfr)=nnyy+1
        nedfr(nnfr)=3
        endif
        if(ipuzn(2,nnyy).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(2,nnyy))
        nfi(nnfi)=nz(nps(nnfi),4)
        ned(nnfi)=4
        else
        nnfr=nnfr+1
        nxfr(nnfr)=2
        nyfr(nnfr)=nnyy
        nedfr(nnfr)=2
        endif
        nnfi=nnfi+1
        nfi(nnfi)=0
        ned(nnfi)=2
        go to 3000
      endif
C
      if(ned(1).eq.4)then
        if(ipuzn(1,nnyy-1).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(1,nnyy-1))
        nfi(nnfi)=nz(nps(nnfi),3)
        ned(nnfi)=3
        else
        nnfr=nnfr+1
        nxfr(nnfr)=1
        nyfr(nnfr)=nnyy-1
        nedfr(nnfr)=1
        endif
        if(ipuzn(1,nnyy+1).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(1,nnyy+1))
        nfi(nnfi)=nz(nps(nnfi),1)
        ned(nnfi)=1
        else
        nnfr=nnfr+1
        nxfr(nnfr)=1
        nyfr(nnfr)=nnyy+1
        nedfr(nnfr)=3
        endif
        nnfi=nnfi+1
        nfi(nnfi)=0
        ned(nnfi)=2
        go to 3000
      endif
C
      endif
C
C  End of case (1,y)
C
C
C     Case with the new piece to be placed at border (x,y=1)
C
      if(nnyy.eq.1)then
      nb=1
      if(ned(1).eq.1)then
        if(ipuzn(nnxx-1,1).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx-1,1))
        nfi(nnfi)=nz(nps(nnfi),2)
        ned(nnfi)=2
        else
        nnfr=nnfr+1
        nxfr(nnfr)=nnxx-1
        nyfr(nnfr)=1
        nedfr(nnfr)=4
        endif
        if(ipuzn(nnxx+1,1).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx+1,1))
        nfi(nnfi)=nz(nps(nnfi),4)
        ned(nnfi)=4
        else
        nnfr=nnfr+1
        nxfr(nnfr)=nnxx+1
        nyfr(nnfr)=1
        nedfr(nnfr)=2
        endif
        nnfi=nnfi+1
        nfi(nnfi)=0
        ned(nnfi)=3
        go to 3000
      endif
C
      if(ned(1).eq.2)then
        if(ipuzn(nnxx+1,1).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx+1,1))
        nfi(nnfi)=nz(nps(nnfi),4)
        ned(nnfi)=4
        else
        nnfr=nnfr+1
        nxfr(nnfr)=nnxx+1
        nyfr(nnfr)=1
        nedfr(nnfr)=2
        endif
        if(ipuzn(nnxx,2).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx,2))
        nfi(nnfi)=nz(nps(nnfi),1)
        ned(nnfi)=1
        else
        nnfr=nnfr+1
        nxfr(nnfr)=nnxx
        nyfr(nnfr)=2
        nedfr(nnfr)=3
        endif
        nnfi=nnfi+1
        nfi(nnfi)=0
        ned(nnfi)=3
        go to 3000
      endif
C
      if(ned(1).eq.4)then
        if(ipuzn(nnxx-1,1).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx-1,1))
        nfi(nnfi)=nz(nps(nnfi),2)
        ned(nnfi)=2
        else
        nnfr=nnfr+1
        nxfr(nnfr)=nnxx-1
        nyfr(nnfr)=1
        nedfr(nnfr)=4
        endif
        if(ipuzn(nnxx,2).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx,2))
        nfi(nnfi)=nz(nps(nnfi),1)
        ned(nnfi)=1
        else
        nnfr=nnfr+1
        nxfr(nnfr)=nnxx
        nyfr(nnfr)=2
        nedfr(nnfr)=3
        endif
        nnfi=nnfi+1
        nfi(nnfi)=0
        ned(nnfi)=3
        go to 3000
      endif
C
      endif
C
C  End of case (x,1)
C
C
C     Case with the new piece to be placed at border (x=nx1,y)
C
      if(nnxx.eq.nx1)then
      nb=1
      if(ned(1).eq.1)then
        if(ipuzn(nx1,nnyy-1).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nx1,nnyy-1))
        nfi(nnfi)=nz(nps(nnfi),3)
        ned(nnfi)=3
        else
        nnfr=nnfr+1
        nxfr(nnfr)=nx1
        nyfr(nnfr)=nnyy-1
        nedfr(nnfr)=1
        endif
        if(ipuzn(nx3,nnyy).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nx3,nnyy))
        nfi(nnfi)=nz(nps(nnfi),2)
        ned(nnfi)=2
        else
        nnfr=nnfr+1
        nxfr(nnfr)=nx3
        nyfr(nnfr)=nnyy
        nedfr(nnfr)=4
        endif
        nnfi=nnfi+1
        nfi(nnfi)=0
        ned(nnfi)=4
       go to 3000
      endif
C
      if(ned(1).eq.2)then
        if(ipuzn(nx1,nnyy-1).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nx1,nnyy-1))
        nfi(nnfi)=nz(nps(nnfi),3)
        ned(nnfi)=3
        else
        nnfr=nnfr+1
        nxfr(nnfr)=nx1
        nyfr(nnfr)=nnyy-1
        nedfr(nnfr)=1
        endif
        if(ipuzn(nx1,nnyy+1).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nx1,nnyy+1))
        nfi(nnfi)=nz(nps(nnfi),1)
        ned(nnfi)=1
        else
        nnfr=nnfr+1
        nxfr(nnfr)=nx1
        nyfr(nnfr)=nnyy+1
        nedfr(nnfr)=3
        endif
        nnfi=nnfi+1
        nfi(nnfi)=0
        ned(nnfi)=4
        go to 3000
      endif
C
      if(ned(1).eq.3)then
        if(ipuzn(nx1,nnyy+1).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nx1,nnyy+1))
        nfi(nnfi)=nz(nps(nnfi),1)
        ned(nnfi)=1
        else
        nnfr=nnfr+1
        nxfr(nnfr)=nx1
        nyfr(nnfr)=nnyy+1
        nedfr(nnfr)=3
        endif
        if(ipuzn(nx3,nnyy).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nx3,nnyy))
        nfi(nnfi)=nz(nps(nnfi),2)
        ned(nnfi)=2
        else
        nnfr=nnfr+1
        nxfr(nnfr)=nx3
        nyfr(nnfr)=nnyy
        nedfr(nnfr)=4
        endif
        nnfi=nnfi+1
        nfi(nnfi)=0
        ned(nnfi)=4
        go to 3000
      endif
C
      endif
C
C  End of case (nx1,y)
C
C
C     Case with the new piece to be placed at border (x,nx2)
C
      if(nnyy.eq.nx2)then
      nb=1
      if(ned(1).eq.2)then
        if(ipuzn(nnxx+1,nx2).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx+1,nx2))
        nfi(nnfi)=nz(nps(nnfi),4)
        ned(nnfi)=4
        else
        nnfr=nnfr+1
        nxfr(nnfr)=nnxx+1
        nyfr(nnfr)=nx2
        nedfr(nnfr)=2
        endif
        if(ipuzn(nnxx,nx4).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx,nx4))
        nfi(nnfi)=nz(nps(nnfi),3)
        ned(nnfi)=3
        else
        nnfr=nnfr+1
        nxfr(nnfr)=nnxx
        nyfr(nnfr)=nx4
        nedfr(nnfr)=1
        endif
        nnfi=nnfi+1
        nfi(nnfi)=0
        ned(nnfi)=1
        go to 3000
      endif
C
      if(ned(1).eq.3)then
        if(ipuzn(nnxx-1,nx2).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx-1,nx2))
        nfi(nnfi)=nz(nps(nnfi),2)
        ned(nnfi)=2
        else
        nnfr=nnfr+1
        nxfr(nnfr)=nnxx-1
        nyfr(nnfr)=nx2
        nedfr(nnfr)=4
        endif
        if(ipuzn(nnxx+1,nx2).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx+1,nx2))
        nfi(nnfi)=nz(nps(nnfi),4)
        ned(nnfi)=4
        else
        nnfr=nnfr+1
        nxfr(nnfr)=nnxx+1
        nyfr(nnfr)=nx2
        nedfr(nnfr)=2
        endif
        nnfi=nnfi+1
        nfi(nnfi)=0
        ned(nnfi)=1
        go to 3000
      endif
C
      if(ned(1).eq.4)then
        if(ipuzn(nnxx-1,nx2).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx-1,nx2))
        nfi(nnfi)=nz(nps(nnfi),2)
        ned(nnfi)=2
        else
        nnfr=nnfr+1
        nxfr(nnfr)=nnxx-1
        nyfr(nnfr)=nx2
        nedfr(nnfr)=4
        endif
        if(ipuzn(nnxx,nx4).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx,nx4))
        nfi(nnfi)=nz(nps(nnfi),3)
        ned(nnfi)=3
        else
        nnfr=nnfr+1
        nxfr(nnfr)=nnxx
        nyfr(nnfr)=nx4
        nedfr(nnfr)=1
        endif
        nnfi=nnfi+1
        nfi(nnfi)=0
        ned(nnfi)=1
        go to 3000
      endif
C
      endif
C
C  End of case (x,nx2)
C
      else
C
C  And now, the general case, not corner nor border
C
      nb=0
      if(ned(1).eq.1)then
        if(ipuzn(nnxx-1,nnyy).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx-1,nnyy))
        nfi(nnfi)=nz(nps(nnfi),2)
        ned(nnfi)=2
        else
        nnfr=nnfr+1
        nxfr(nnfr)=nnxx-1
        nyfr(nnfr)=nnyy
        nedfr(nnfr)=4
        endif
        if(ipuzn(nnxx,nnyy-1).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx,nnyy-1))
        nfi(nnfi)=nz(nps(nnfi),3)
        ned(nnfi)=3
        else
        nnfr=nnfr+1
        nxfr(nnfr)=nnxx
        nyfr(nnfr)=nnyy-1
        nedfr(nnfr)=1
        endif
        if(ipuzn(nnxx+1,nnyy).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx+1,nnyy))
        nfi(nnfi)=nz(nps(nnfi),4)
        ned(nnfi)=4
        else
        nnfr=nnfr+1
        nxfr(nnfr)=nnxx+1
        nyfr(nnfr)=nnyy
        nedfr(nnfr)=2
        endif
        go to 3000
      endif
C
      if(ned(1).eq.2)then
        if(ipuzn(nnxx,nnyy-1).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx,nnyy-1))
        nfi(nnfi)=nz(nps(nnfi),3)
        ned(nnfi)=3
        else
        nnfr=nnfr+1
        nxfr(nnfr)=nnxx
        nyfr(nnfr)=nnyy-1
        nedfr(nnfr)=1
        endif
        if(ipuzn(nnxx+1,nnyy).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx+1,nnyy))
        nfi(nnfi)=nz(nps(nnfi),4)
        ned(nnfi)=4
        else
        nnfr=nnfr+1
        nxfr(nnfr)=nnxx+1
        nyfr(nnfr)=nnyy
        nedfr(nnfr)=2
        endif
        if(ipuzn(nnxx,nnyy+1).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx,nnyy+1))
        nfi(nnfi)=nz(nps(nnfi),1)
        ned(nnfi)=1
        else
        nnfr=nnfr+1
        nxfr(nnfr)=nnxx
        nyfr(nnfr)=nnyy+1
        nedfr(nnfr)=3
        endif
        go to 3000
      endif
C
      if(ned(1).eq.3)then
        if(ipuzn(nnxx+1,nnyy).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx+1,nnyy))
        nfi(nnfi)=nz(nps(nnfi),4)
        ned(nnfi)=4
        else
        nnfr=nnfr+1
        nxfr(nnfr)=nnxx+1
        nyfr(nnfr)=nnyy
        nedfr(nnfr)=2
        endif
        if(ipuzn(nnxx,nnyy+1).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx,nnyy+1))
        nfi(nnfi)=nz(nps(nnfi),1)
        ned(nnfi)=1
        else
        nnfr=nnfr+1
        nxfr(nnfr)=nnxx
        nyfr(nnfr)=nnyy+1
        nedfr(nnfr)=3
        endif
        if(ipuzn(nnxx-1,nnyy).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx-1,nnyy))
        nfi(nnfi)=nz(nps(nnfi),2)
        ned(nnfi)=2
        else
        nnfr=nnfr+1
        nxfr(nnfr)=nnxx-1
        nyfr(nnfr)=nnyy
        nedfr(nnfr)=4
        endif
        go to 3000
      endif
C
      if(ned(1).eq.4)then
        if(ipuzn(nnxx,nnyy+1).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx,nnyy+1))
        nfi(nnfi)=nz(nps(nnfi),1)
        ned(nnfi)=1
        else
        nnfr=nnfr+1
        nxfr(nnfr)=nnxx
        nyfr(nnfr)=nnyy+1
        nedfr(nnfr)=3
        endif
        if(ipuzn(nnxx-1,nnyy).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx-1,nnyy))
        nfi(nnfi)=nz(nps(nnfi),2)
        ned(nnfi)=2
        else
        nnfr=nnfr+1
        nxfr(nnfr)=nnxx-1
        nyfr(nnfr)=nnyy
        nedfr(nnfr)=4
        endif
        if(ipuzn(nnxx,nnyy-1).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx,nnyy-1))
        nfi(nnfi)=nz(nps(nnfi),3)
        ned(nnfi)=3
        else
        nnfr=nnfr+1
        nxfr(nnfr)=nnxx
        nyfr(nnfr)=nnyy-1
        nedfr(nnfr)=1
        endif
        go to 3000
      endif
C
C  End of checking for neighbours of the possible new piece
C 
      endif
C
C
C
3000  continue
C
C  Now, search for the possibly corresponding piece among 
C       the remaining ones
C
C
      go to (3001,3002,3003,3004)nnfi
C
C     Case with only one neigbour nnfi = 1
C
3001  continue
C
C     OK, only one figure to satisfy, then it is always = nfi(1) 
C         so, is there any remaining piece with that figure ?
C         care also to the nb value...
C              nb=2 then this is a piece to place at a corner
C              nb=1 then this is a piece to place at a border
C              nb=0 then this is a piece to place elsewhere
C
      nnot=0
      kfig=nfi(1)+1
C
C
C
      num=nnfig(kfig)
      if(num.eq.0)then
        iplus=0
        go to 499
      endif
C
C    If yes, then select one randomly...
C
C          or maybe not so randomly according to nsym...
C
C   Correspondences of edges
C
      call corned(ned,nned)
C
      if(nb.eq.0)then
      if(num.ge.1)then
      new=int(float(num)*randi(iseed))+1
      if(new.gt.num)new=num
      newp=mmfig(kfig,new)
      else
      iplus=0
      go to 499
      endif
      endif
C
C    Rotate the piece and place it on the puzzle
C        at position (nnxx,nnyy)
C
6001  continue
C
C   At this point, there is some checking loop...
C                  = backtracking at first level
C
C   Hey, but we cannot go there more than num times... 
C
      if(nnot.ge.num)then
        iplus=0
        go to 499
      endif
      npz=npz+1
      ipuzn(nnxx,nnyy)=newp
      ni(newp)=npz
      nx(npz)=nnxx
      ny(npz)=nnyy
C
C Find the rotation ir by locating where is the figure
C
      do i=1,4
      if(np(newp,i).eq.nfi(1))go to 432
      enddo
C
C!!!  but if there are 2 or 3 times the same figure ?
C     then select one randomly...
C
C
432   continue
      if(i.eq.nned(1))ir=0
      if(i.eq.(nned(1)-1))ir=1
      if(i.eq.(nned(1)-2))ir=2
      if(i.eq.(nned(1)-3))ir=3
      if(i.eq.(nned(1)+1))ir=3
      if(i.eq.(nned(1)+2))ir=2
      if(i.eq.(nned(1)+3))ir=1
      ih=newp
      call rot(ih,npz,ir)
289   format(2x,i4,2x,4i4,2x,4i4)
C
C   Remove this piece already placed from the lists nnfig and mmfig
C
C
C  in memory
C
      do i=1,ifign
      nnnnfig(i)=nnfig(i)
      enddo
      do i=1,ifign
      do j=1,nnfig(i)
      mmmmfig(i,j)=mmfig(i,j)
      enddo
      enddo
C
C  remove
C
      do i=1,ifign
      nnnfig(i)=0
      do j=1,nnfig(i)
      if(mmfig(i,j).ne.ipuzn(nnxx,nnyy))then
      nnnfig(i)=nnnfig(i)+1
      mmmfig(i,nnnfig(i))=mmfig(i,j)
      endif
      enddo
      enddo
C
C  update
C
      do i=1,ifign
      nnfig(i)=nnnfig(i)
      enddo
      do i=1,ifign
      do j=1,nnfig(i)
      mmfig(i,j)=mmmfig(i,j)
      enddo
      enddo
C
      num=nnfig(kfig)
C
C
C
C  And now, check if that piece was a good idea or not...
C      check only if num >1 otherwise, there is no choice...
C
C
      if(nnfr.ne.0.and.num.ne.1)then
      nnot=nnot+1
      ncheckt=0
      do j=1,nnfr
      call backtr(npz,j)
C
      ncheckt=ncheckt+ncheck(j)
      enddo
      if(ncheckt.ne.0)then
C
C  it was not a good idea
C        so, remove it
C        and reinit some things
C
      nott(nnot)=newp
      ipuzn(nnxx,nnyy)=0
      npz=npz-1
      do i=1,ifign
      nnfig(i)=nnnnfig(i)
      enddo
      do i=1,ifign
      do j=1,nnfig(i)
      mmfig(i,j)=mmmmfig(i,j)
      enddo
      enddo
C
C  Was it the last chance ?
C
      if(nnot.ge.num)then
        iplus=0
        go to 499
      endif
C
C   Well, if it is not OK, then it will be another one, maybe...
C
      num=0
      do i=1,nnfig(kfig)
      m=mmfig(kfig,i)
      do j=1,nnot
      if(m.ne.nott(j))then
      num=num+1
      mfig0(num)=m
      go to 601
      endif
      enddo
601   continue
      enddo
      if(num.ge.1)then
      new=int(float(num)*randi(iseed))+1
      if(new.gt.num)new=num
      newp=mfig0(new)
      go to 6001
      endif
C
C   end of inacceptable part... 
C
      endif
C
C   so it was acceptable... let us continue
C
      endif
C
      if(nnfr.ne.0)then
        newp=ipuzn(nnxx,nnyy)
        do i=1,nnfr
        if(nforce(i).ne.0)then
        ifor=ifor+1
        npfr(ifor)=npz
        nedfr2(ifor)=nedfr(i)
C        write(10,*)'nf,npz,newp,nedfr',i,npz,newp,nedfr(i)
        endif
        enddo
      endif
C
C   How many new edge couples satisfied ?
C        only one in this case
C
      iedges=0
      ibad=0
      call edges(nnxx,nnyy,iedges,ibad,ipuzn,ni,nz)
      nsum=nsum+iedges
C
C
C
      if(nsum.gt.nsumax)then
      do i=1,nxmax
      nis(i)=ni(i)
      enddo
      do i=1,npz
      nxs(i)=nx(i)
      nys(i)=ny(i)
      do j=1,4
      nzs(i,j)=nz(i,j)
      enddo
      enddo
      npzs=npz
      do i=1,nx1
      do j=1,nx2
      ipuzns(i,j)=ipuzn(i,j)
      enddo
      enddo
      nsumax=nsum
      bestm=nmove
C
C  Verbosity
C
      if(iverb.ge.1)then
      write(*,120)nsum,npz,iii,nmove
      write(10,120)nsum,npz,iii,nmove
      write(10,*)
      write(10,*)
      write(10,*)' Total number of placed pieces :',npzs
      write(10,*)
      write(10,*)' Table with all pieces :'
      write(10,*)
      write(10,*)'        1   2   3   4   5   6   7   8   9  10  11  12 
     1 13  14  15  16'
      write(10,*)
      do i=1,nx2
      write(10,288)i,(ipuzns(j,i),j=1,nx1)
      enddo
C
C  Final check on edges satisfied...
C
      iedges=0
      ibad=0
      call chekedge(iedges,ibad,ipuzns,nis,nzs)
      write(10,*)
      write(10,*)'  Shared edges :',iedges
      write(10,*)'  Bad edges    :',ibad
      write(10,*)
C
C
      endif
C
C  end verbosity
C
      endif
120   format(' edges,pieces,etc...',2i4,1x,i12,2x,f12.0,i4)
C
C
C   Go to select another edge to satisfy
C
      iplus=1
      go to 499
C
C
C
C     Case with two neigbours       nnfi = 2
C              adjacent or
C              opposite
3002  continue
C
C     OK, two figures to satisfy,  
C       so, is there any remaining piece(s) with these figures ?
C       care also to the nb value...
C              nb=2 then this is a piece to place at a corner
C              nb=1 then this is a piece to place at a border
C              nb=0 then this is a piece to place elsewhere
C
      nnot=0
      kfig=nfi(1)+1
C
C  Special cases
C      a)   border    
C
      if(nb.eq.1)kfig=1
C
C
      num=nnfig(kfig)
      if(num.eq.0)then
        iplus=0
        go to 499
      endif
C
C    If yes, then select one randomly...
C
C          or maybe not so randomly according to nsym...
C
C   Correspondences of edges
C
      call corned(ned,nned)
C
      if(nb.eq.0)then
C
C    First, built the list of possibilities
C                  with such two figures...
C
C  Create a special list of pieces containing both nfi(1) and nfi(2)
C                  at the right respective places
C                  either adjacent or opposite
C
      num=0
      do i=1,nnfig(nfi(1)+1)
      m=mmfig(nfi(1)+1,i)
      do j=1,4
      i2=nned(2)+j
      i1=nned(1)+j
      if(i1.gt.4)i1=i1-4
      if(i2.gt.4)i2=i2-4
      if(np(m,i2).eq.nfi(2).and.np(m,i1).eq.nfi(1))then
      num=num+1
      mfig0(num)=m
      go to 2001
      endif
      enddo
2001  continue
      enddo
      if(num.ge.1)then
      new=int(float(num)*randi(iseed))+1
      if(new.gt.num)new=num
      newp=mfig0(new)
      else
      iplus=0
      go to 499
      endif
      endif
C
C
C
      if(nb.eq.1)then
C
C    First, built the list of possibilities
C                  with such two figures...
C
C  Create a special list of pieces containing both nfi(1) and nfi(2)
C
      num=0
      do i=1,nnfig(1)
      m=mmfig(1,i)
      do j=1,4
      i2=nned(2)+j
      i1=nned(1)+j
      if(i1.gt.4)i1=i1-4
      if(i2.gt.4)i2=i2-4
      if(np(m,i2).eq.nfi(2).and.np(m,i1).eq.nfi(1))then
      num=num+1
      mfig0(num)=m
      go to 2002
      endif
      enddo
2002  continue
      enddo
      if(num.ge.1)then
      new=int(float(num)*randi(iseed))+1
      if(new.gt.num)new=num
      newp=mfig0(new)
      else
      iplus=0
      go to 499
      endif
      endif
C
C    Rotate the piece and place it on the puzzle
C        at position (nnxx,nnyy)
C
6002  continue
C
C   At this point, there is somme checking loop...
C                  = backtracking on one first level
C
C   Hey, but we cannot go there more than num times... 
C
      if(nnot.ge.num)then
        iplus=0
        go to 499
      endif
      npz=npz+1
      ipuzn(nnxx,nnyy)=newp
      ni(newp)=npz
      nx(npz)=nnxx
      ny(npz)=nnyy
C
C Find the rotation ir by locating where is the figure
C
      m=newp
      do j=1,4
      i2=nned(2)+j
      i1=nned(1)+j
      if(i1.gt.4)i1=i1-4
      if(i2.gt.4)i2=i2-4
      if(np(m,i2).eq.nfi(2).and.np(m,i1).eq.nfi(1))then
      jr=i1
      endif
      enddo
      if(jr.eq.nned(1))ir=0
      if(jr.eq.(nned(1)-1))ir=1
      if(jr.eq.(nned(1)-2))ir=2
      if(jr.eq.(nned(1)-3))ir=3
      if(jr.eq.(nned(1)+1))ir=3
      if(jr.eq.(nned(1)+2))ir=2
      if(jr.eq.(nned(1)+3))ir=1
      ih=newp
      call rot(ih,npz,ir)
C
C   Remove the piece already placed from the lists nnfig and mmfig
C
C  in memory
C
      do i=1,ifign
      nnnnfig(i)=nnfig(i)
      enddo
      do i=1,ifign
      do j=1,nnfig(i)
      mmmmfig(i,j)=mmfig(i,j)
      enddo
      enddo
C
C  remove
C
      do i=1,ifign
      nnnfig(i)=0
      do j=1,nnfig(i)
      if(mmfig(i,j).ne.ipuzn(nnxx,nnyy))then
      nnnfig(i)=nnnfig(i)+1
      mmmfig(i,nnnfig(i))=mmfig(i,j)
      endif
      enddo
      enddo
C
C  update
C
      do i=1,ifign
      nnfig(i)=nnnfig(i)
      enddo
      do i=1,ifign
      do j=1,nnfig(i)
      mmfig(i,j)=mmmfig(i,j)
      enddo
      enddo
C
C
C
C
C  And now, check if that piece was a good idea or not...
C      check only if num >1 otherwise, there is no choice...
C
C
      if(nnfr.ne.0.and.num.ne.1)then
      nnot=nnot+1
      ncheckt=0
      do j=1,nnfr
      call backtr(npz,j)
C
      ncheckt=ncheckt+ncheck(j)
      enddo
      if(ncheckt.ne.0)then
C
C  it was not a good idea
C        so, remove it
C        and reinit some things
C
      nott(nnot)=newp
      ipuzn(nnxx,nnyy)=0
      npz=npz-1
      do i=1,ifign
      nnfig(i)=nnnnfig(i)
      enddo
      do i=1,ifign
      do j=1,nnfig(i)
      mmfig(i,j)=mmmmfig(i,j)
      enddo
      enddo
C
C  Was it the last chance ?
C
      if(nnot.ge.num)then
       iplus=0
       go to 499
      endif
C
C   Well, if it is not OK, then it will be another one, maybe...
C
      num2=0
      do i=1,num
      m=mfig0(i)
      do j=1,nnot
      if(m.ne.nott(j))then
      num2=num2+1
      mfig02(num2)=m
      mfig0(num2)=m
      go to 602
      endif
      enddo
602   continue
      enddo
      num=num2
      if(num.ge.1)then
      new=int(float(num)*randi(iseed))+1
      if(new.gt.num)new=num
      newp=mfig02(new)
      go to 6002
      endif
C
C   end of inacceptable part... 
C
      endif
C
C   so it was acceptable... let us continue
C
      endif
C
      if(nnfr.ne.0)then
        newp=ipuzn(nnxx,nnyy)
        do i=1,nnfr
        if(nforce(i).ne.0)then
        ifor=ifor+1
        npfr(ifor)=npz
        nedfr2(ifor)=nedfr(i)
C        write(10,*)'nf,npz,newp,nedfr',i,npz,newp,nedfr(i)
        endif
        enddo
      endif
C
C   How many new edge couples satisfied ?
C        two in this case
C
      iedges=0
      ibad=0
      call edges(nnxx,nnyy,iedges,ibad,ipuzn,ni,nz)
      nsum=nsum+iedges
C
C
C
      if(nsum.gt.nsumax)then
      do i=1,nxmax
      nis(i)=ni(i)
      enddo
      do i=1,npz
      nxs(i)=nx(i)
      nys(i)=ny(i)
      do j=1,4
      nzs(i,j)=nz(i,j)
      enddo
      enddo
      npzs=npz
      do i=1,nx1
      do j=1,nx2
      ipuzns(i,j)=ipuzn(i,j)
      enddo
      enddo
      nsumax=nsum
      bestm=nmove
C
C  Verbosity
C
      if(iverb.ge.1)then
      write(*,120)nsum,npz,iii,nmove
      write(10,120)nsum,npz,iii,nmove
      write(10,*)
      write(10,*)
      write(10,*)' Total number of placed pieces :',npzs
      write(10,*)
      write(10,*)' Table with all pieces :'
      write(10,*)
      write(10,*)'        1   2   3   4   5   6   7   8   9  10  11  12 
     1 13  14  15  16'
      write(10,*)
      do i=1,nx2
      write(10,288)i,(ipuzns(j,i),j=1,nx1)
      enddo
C
C  Final check on edges satisfied...
C
      iedges=0
      ibad=0
      call chekedge(iedges,ibad,ipuzns,nis,nzs)
      write(10,*)
      write(10,*)'  Shared edges :',iedges
      write(10,*)'  Bad edges    :',ibad
      write(10,*)
C
C
      endif
C
C  end verbosity
C
      endif
C
C
C   Go to select another edge to satisfy
C
      iplus=1
      go to 499
C
C     Case with three neigbours    nnfi = 3
C
3003  continue
C
C     OK, three figures to satisfy,  
C       so, is there any remaining piece(s) with these figures ?
C       care also to the nb value...
C              nb=2 then this is a piece to place at a corner
C              nb=1 then this is a piece to place at a border
C              nb=0 then this is a piece to place elsewhere
C
      nnot=0
      kfig=nfi(1)+1
C
C  Special cases
C      a)   border    
C
      if(nb.eq.1)kfig=1
C
C      b)  corner
C
      if(nb.eq.2)kfig=ifign
C
C
      num=nnfig(kfig)
      if(num.eq.0)then
        iplus=0
        go to 499
      endif
C
C    If yes, then select one randomly...
C
C          or maybe not so randomly according to nsym...
C
C   Correspondences of edges
C
      call corned(ned,nned)
C
C
C
      if(nb.eq.0)then
C
C    First, build the list of possibilities
C                  with such three figures...
C
C  Create a special list of pieces containing nfi(1),nfi(2)and nfi(3)
C                  at the right respective places
C
      num=0
      do i=1,nnfig(nfi(1)+1)
      m=mmfig(nfi(1)+1,i)
      do j=1,4
      i3=nned(3)+j
      i2=nned(2)+j
      i1=nned(1)+j
      j1=nfi(1)
      j2=nfi(2)
      j3=nfi(3)
      if(i1.gt.4)i1=i1-4
      if(i2.gt.4)i2=i2-4
      if(i3.gt.4)i3=i3-4
      if(np(m,i1).eq.j1.and.np(m,i2).eq.j2.and.np(m,i3).eq.j3)then
      num=num+1
      mfig0(num)=m
      go to 2004
      endif
      enddo
2004  continue
      enddo
      if(num.ge.1)then
      new=int(float(num)*randi(iseed))+1
      if(new.gt.num)new=num
      newp=mfig0(new)
      else
      iplus=0
      go to 499
      endif
      endif
C
C
C
      if(nb.eq.1)then
C
C    First, built the list of possibilities
C                  with such three figures...
C
C  Create a special list of pieces containing nfi(1), nfi(2) and nfi(3)
C
      num=0
      do i=1,nnfig(1)
      m=mmfig(1,i)
      do j=1,4
      i3=nned(3)+j
      i2=nned(2)+j
      i1=nned(1)+j
      j1=nfi(1)
      j2=nfi(2)
      j3=nfi(3)
      if(i1.gt.4)i1=i1-4
      if(i2.gt.4)i2=i2-4
      if(i3.gt.4)i3=i3-4
      if(np(m,i1).eq.j1.and.np(m,i2).eq.j2.and.np(m,i3).eq.j3)then
      num=num+1
      mfig0(num)=m
      go to 2005
      endif
      enddo
2005  continue
      enddo
      if(num.ge.1)then
      new=int(float(num)*randi(iseed))+1
      if(new.gt.num)new=num
      newp=mfig0(new)
      else
      iplus=0
      go to 499
      endif
      endif
C
C
C
      if(nb.eq.2)then
C
C    First, built the list of possibilities
C                  with such three figures...
C
C  Create a special list of pieces containing nfi(1), nfi(2) and nfi(3)
C
      num=0
      do i=1,nnfig(ifign)
      m=mmfig(ifign,i)
      do j=1,4
      i3=nned(3)+j
      i2=nned(2)+j
      i1=nned(1)+j
      j1=nfi(1)
      j2=nfi(2)
      j3=nfi(3)
      if(i1.gt.4)i1=i1-4
      if(i2.gt.4)i2=i2-4
      if(i3.gt.4)i3=i3-4
      if(np(m,i1).eq.j1.and.np(m,i2).eq.j2.and.np(m,i3).eq.j3)then
      num=num+1
      mfig0(num)=m
      go to 2012
      endif
      enddo
2012  continue
      enddo
      if(num.ge.1)then
      new=int(float(num)*randi(iseed))+1
      if(new.gt.num)new=num
      newp=mfig0(new)
      else
      iplus=0
      go to 499
      endif
      endif
C
C    Rotate the piece and place it on the puzzle
C        at position (nnxx,nnyy)
C
6003  continue
C
C   At this point, there is somme checking loop...
C                  = backtracking on one first level
C
C   Hey, but we cannot go there more than num times... 
C
      if(nnot.ge.num)then
       iplus=0
       go to 499
      endif
      npz=npz+1
      ipuzn(nnxx,nnyy)=newp
      ni(newp)=npz
      nx(npz)=nnxx
      ny(npz)=nnyy
C
C Find the rotation ir by locating where is the figure
C
      m=newp
      do j=1,4
      i3=nned(3)+j
      i2=nned(2)+j
      i1=nned(1)+j
      j1=nfi(1)
      j2=nfi(2)
      j3=nfi(3)
      if(i1.gt.4)i1=i1-4
      if(i2.gt.4)i2=i2-4
      if(i3.gt.4)i3=i3-4
      if(np(m,i1).eq.j1.and.np(m,i2).eq.j2.and.np(m,i3).eq.j3)then
      jr=i1
      endif
      enddo
      if(jr.eq.nned(1))ir=0
      if(jr.eq.(nned(1)-1))ir=1
      if(jr.eq.(nned(1)-2))ir=2
      if(jr.eq.(nned(1)-3))ir=3
      if(jr.eq.(nned(1)+1))ir=3
      if(jr.eq.(nned(1)+2))ir=2
      if(jr.eq.(nned(1)+3))ir=1
      ih=newp
      call rot(ih,npz,ir)
C
C   Remove the piece already placed from the lists nnfig and mmfig
C
C  in memory
C
      do i=1,ifign
      nnnnfig(i)=nnfig(i)
      enddo
      do i=1,ifign
      do j=1,nnfig(i)
      mmmmfig(i,j)=mmfig(i,j)
      enddo
      enddo
C
C  remove
C
      do i=1,ifign
      nnnfig(i)=0
      do j=1,nnfig(i)
      if(mmfig(i,j).ne.ipuzn(nnxx,nnyy))then
      nnnfig(i)=nnnfig(i)+1
      mmmfig(i,nnnfig(i))=mmfig(i,j)
      endif
      enddo
      enddo
C
C  update
C
      do i=1,ifign
      nnfig(i)=nnnfig(i)
      enddo
      do i=1,ifign
      do j=1,nnfig(i)
      mmfig(i,j)=mmmfig(i,j)
      enddo
      enddo
C
C
C
C
C  And now, check if that piece was a good idea or not...
C      check only if num >1 otherwise, there is no choice...
C
C
      if(nnfr.ne.0.and.num.ne.1)then
      nnot=nnot+1
      ncheckt=0
      do j=1,nnfr
      call backtr(npz,j)
C
      ncheckt=ncheckt+ncheck(j)
      enddo
      if(ncheckt.ne.0)then
C
C  it was not a good idea
C        so, remove it
C        and reinit some things
C
      nott(nnot)=newp
      ipuzn(nnxx,nnyy)=0
      npz=npz-1
      do i=1,ifign
      nnfig(i)=nnnnfig(i)
      enddo
      do i=1,ifign
      do j=1,nnfig(i)
      mmfig(i,j)=mmmmfig(i,j)
      enddo
      enddo
C
C  Was it the last chance ?
C
      if(nnot.ge.num)then
       iplus=0
       go to 499
      endif
C
C   Well, if it is not OK, then it will be another one, maybe...
C
      num2=0
      do i=1,num
      m=mfig0(i)
      do j=1,nnot
      if(m.ne.nott(j))then
      num2=num2+1
      mfig02(num2)=m
      mfig0(num2)=m
      go to 603
      endif
      enddo
603   continue
      enddo
      num=num2
      if(num.ge.1)then
      new=int(float(num)*randi(iseed))+1
      if(new.gt.num)new=num
      newp=mfig02(new)
      go to 6003
      endif
C
C   end of inacceptable part... 
C
      endif
C
C   so it was acceptable... let us continue
C
      endif
C
      if(nnfr.ne.0)then
        newp=ipuzn(nnxx,nnyy)
        do i=1,nnfr
        if(nforce(i).ne.0)then
        ifor=ifor+1
        npfr(ifor)=npz
        nedfr2(ifor)=nedfr(i)
C        write(10,*)'nf,npz,newp,nedfr',i,npz,newp,nedfr(i)
        endif
        enddo
      endif
C
C   How many new edge couples satisfied ?
C        three in this case,
C         unless there was a border, then it will be 2
C
      iedges=0
      ibad=0
      call edges(nnxx,nnyy,iedges,ibad,ipuzn,ni,nz)
      nsum=nsum+iedges
C
C
C
      if(nsum.gt.nsumax)then
      do i=1,nxmax
      nis(i)=ni(i)
      enddo
      do i=1,npz
      nxs(i)=nx(i)
      nys(i)=ny(i)
      do j=1,4
      nzs(i,j)=nz(i,j)
      enddo
      enddo
      npzs=npz
      do i=1,nx1
      do j=1,nx2
      ipuzns(i,j)=ipuzn(i,j)
      enddo
      enddo
      nsumax=nsum
      bestm=nmove
C
C  Verbosity
C
      if(iverb.ge.1)then
      write(*,120)nsum,npz,iii,nmove
      write(10,120)nsum,npz,iii,nmove
      write(10,*)
      write(10,*)
      write(10,*)' Total number of placed pieces :',npzs
      write(10,*)
      write(10,*)' Table with all pieces :'
      write(10,*)
      write(10,*)'        1   2   3   4   5   6   7   8   9  10  11  12 
     1 13  14  15  16'
      write(10,*)
      do i=1,nx2
      write(10,288)i,(ipuzns(j,i),j=1,nx1)
      enddo
C
C  Final check on edges satisfied...
C
      iedges=0
      ibad=0
      call chekedge(iedges,ibad,ipuzns,nis,nzs)
      write(10,*)
      write(10,*)'  Shared edges :',iedges
      write(10,*)'  Bad edges    :',ibad
      write(10,*)
C
C
      endif
C
C  end verbosity
C
      endif
C
C
C   Go to select another edge to satisfy
C
      iplus=1
      go to 499
C
C     Case with 4 neigbours       nnfi = 4
C
3004  continue
C
C     OK, four figures to satisfy,  
C       so, is there any remaining piece(s) with these figures ?
C       care also to the nb value...
C              nb=2 then this is a piece to place at a corner
C              nb=1 then this is a piece to place at a border
C              nb=0 then this is a piece to place elsewhere
C
      nnot=0
      kfig=nfi(1)+1
C
C  Special cases
C      a)   border    
C
      if(nb.eq.1)kfig=1
C
C      b)  corner
C
      if(nb.eq.2)kfig=ifign
C
C
      num=nnfig(kfig)
      if(num.eq.0)then
        iplus=0
        go to 499
      endif
C
C    If yes, then select one randomly...
C
C          or maybe not so randomly according to nsym...
C
C   Correspondences of edges
C
      call corned(ned,nned)
C
C
C
      if(nb.eq.0)then
C
C    First, build the list of possibilities
C                  with such four figures...
C
C  Create a special list of pieces containing 
C                        nfi(1),nfi(2),nfi(3) and nfi(4)
C                  at the right respective places
C
      num=0
      do i=1,nnfig(nfi(1)+1)
      m=mmfig(nfi(1)+1,i)
      do j=1,4
      i4=nned(4)+j
      i3=nned(3)+j
      i2=nned(2)+j
      i1=nned(1)+j
      j1=nfi(1)
      j2=nfi(2)
      j3=nfi(3)
      j4=nfi(4)
      if(i1.gt.4)i1=i1-4
      if(i2.gt.4)i2=i2-4
      if(i3.gt.4)i3=i3-4
      if(i4.gt.4)i4=i4-4
      if(np(m,i1).eq.j1.and.np(m,i2).eq.j2.and.np(m,i3).eq.j3.
     1and.np(m,i4).eq.j4)then
      num=num+1
      mfig0(num)=m
      go to 2007
      endif
      enddo
2007  continue
      enddo
      if(num.ge.1)then
      new=int(float(num)*randi(iseed))+1
      if(new.gt.num)new=num
      newp=mfig0(new)
      else
      iplus=0
      go to 499
      endif
      endif
C
C
C
      if(nb.eq.1)then
C
C    First, built the list of possibilities
C                  with such three figures...
C
C  Create a special list of pieces containing nfi(1), nfi(2) and nfi(3)
C
      num=0
      do i=1,nnfig(1)
      m=mmfig(1,i)
      do j=1,4
      i4=nned(4)+j
      i3=nned(3)+j
      i2=nned(2)+j
      i1=nned(1)+j
      j1=nfi(1)
      j2=nfi(2)
      j3=nfi(3)
      j4=nfi(4)
      if(i1.gt.4)i1=i1-4
      if(i2.gt.4)i2=i2-4
      if(i3.gt.4)i3=i3-4
      if(i4.gt.4)i4=i4-4
      if(np(m,i1).eq.j1.and.np(m,i2).eq.j2.and.np(m,i3).eq.j3.
     1and.np(m,i4).eq.j4)then
      num=num+1
      mfig0(num)=m
      go to 2008
      endif
      enddo
2008  continue
      enddo
      if(num.ge.1)then
      new=int(float(num)*randi(iseed))+1
      if(new.gt.num)new=num
      newp=mfig0(new)
      else
      iplus=0
      go to 499
      endif
      endif
C
C   Piece at a corner
C
      if(nb.eq.2)then
C
C    First, built the list of possibilities
C                  with such three figures...
C
C  Create a special list of pieces containing 
C                       nfi(1), nfi(2), nfi(3) and nfi(4)
C
      num=0
      do i=1,nnfig(ifign)
      m=mmfig(ifign,i)
      do j=1,4
      i4=nned(4)+j
      i3=nned(3)+j
      i2=nned(2)+j
      i1=nned(1)+j
      j1=nfi(1)
      j2=nfi(2)
      j3=nfi(3)
      j4=nfi(4)
      if(i1.gt.4)i1=i1-4
      if(i2.gt.4)i2=i2-4
      if(i3.gt.4)i3=i3-4
      if(i4.gt.4)i4=i4-4
      if(np(m,i1).eq.j1.and.np(m,i2).eq.j2.and.np(m,i3).eq.j3.
     1and.np(m,i4).eq.j4)then
      num=num+1
      mfig0(num)=m
      go to 2009
      endif
      enddo
2009  continue
      enddo
      if(num.ge.1)then
      new=int(float(num)*randi(iseed))+1
      if(new.gt.num)new=num
      newp=mfig0(new)
      else
      iplus=0
      go to 499
      endif
      endif
C
C
C    Rotate the piece and place it on the puzzle
C        at position (nnxx,nnyy)
C
6004  continue
C
C   At this point, there is somme checking loop...
C                  = backtracking on one first level
C
C   Hey, but we cannot go there more than num times... 
C
      if(nnot.ge.num)then
        iplus=0
        go to 499
      endif
      npz=npz+1
      ipuzn(nnxx,nnyy)=newp
      ni(newp)=npz
      nx(npz)=nnxx
      ny(npz)=nnyy
C
C Find the rotation ir by locating where is the figure
C
      m=newp
      do j=1,4
      i4=nned(4)+j
      i3=nned(3)+j
      i2=nned(2)+j
      i1=nned(1)+j
      j1=nfi(1)
      j2=nfi(2)
      j3=nfi(3)
      j4=nfi(4)
      if(i1.gt.4)i1=i1-4
      if(i2.gt.4)i2=i2-4
      if(i3.gt.4)i3=i3-4
      if(i4.gt.4)i4=i4-4
      if(np(m,i1).eq.j1.and.np(m,i2).eq.j2.and.np(m,i3).eq.j3.
     1and.np(m,i4).eq.j4)then
      jr=i1
      endif
      enddo
      if(jr.eq.nned(1))ir=0
      if(jr.eq.(nned(1)-1))ir=1
      if(jr.eq.(nned(1)-2))ir=2
      if(jr.eq.(nned(1)-3))ir=3
      if(jr.eq.(nned(1)+1))ir=3
      if(jr.eq.(nned(1)+2))ir=2
      if(jr.eq.(nned(1)+3))ir=1
      ih=newp
      call rot(ih,npz,ir)
C
C   Remove the piece already placed from the lists nnfig and mmfig
C
C  in memory
C
      do i=1,ifign
      nnnnfig(i)=nnfig(i)
      enddo
      do i=1,ifign
      do j=1,nnfig(i)
      mmmmfig(i,j)=mmfig(i,j)
      enddo
      enddo
C
C  remove
C
      do i=1,ifign
      nnnfig(i)=0
      do j=1,nnfig(i)
      if(mmfig(i,j).ne.ipuzn(nnxx,nnyy))then
      nnnfig(i)=nnnfig(i)+1
      mmmfig(i,nnnfig(i))=mmfig(i,j)
      endif
      enddo
      enddo
C
C  update
C
      do i=1,ifign
      nnfig(i)=nnnfig(i)
      enddo
      do i=1,ifign
      do j=1,nnfig(i)
      mmfig(i,j)=mmmfig(i,j)
      enddo
      enddo
C
C
C
C  And now, check if that piece was a good idea or not...
C      check only if num >1 otherwise, there is no choice...
C
C
      if(nnfr.ne.0.and.num.ne.1)then
      nnot=nnot+1
      ncheckt=0
      do j=1,nnfr
      call backtr(npz,j)
C
      ncheckt=ncheckt+ncheck(j)
      enddo
      if(ncheckt.ne.0)then
C
C  it was not a good idea
C        so, remove it
C        and reinit some things
C
      nott(nnot)=newp
      ipuzn(nnxx,nnyy)=0
      npz=npz-1
      do i=1,ifign
      nnfig(i)=nnnnfig(i)
      enddo
      do i=1,ifign
      do j=1,nnfig(i)
      mmfig(i,j)=mmmmfig(i,j)
      enddo
      enddo
C
C  Was it the last chance ?
C
      if(nnot.ge.num)then
        iplus=0
        go to 499
      endif
C
C   Well, if it is not OK, then it will be another one, maybe...
C
      num2=0
      do i=1,num
      m=mfig0(i)
      do j=1,nnot
      if(m.ne.nott(j))then
      num2=num2+1
      mfig02(num2)=m
      mfig0(num2)=m
      go to 604
      endif
      enddo
604   continue
      enddo
      num=num2
      if(num.ge.1)then
      new=int(float(num)*randi(iseed))+1
      if(new.gt.num)new=num
      newp=mfig02(new)
      go to 6004
      endif
C
C   end of inacceptable part... 
C
      endif
C
C   so it was acceptable... let us continue
C
      endif
C
      if(nnfr.ne.0)then
        newp=ipuzn(nnxx,nnyy)
        do i=1,nnfr
        if(nforce(i).ne.0)then
        ifor=ifor+1
        npfr(ifor)=npz
        nedfr2(ifor)=nedfr(i)
C        write(10,*)'nf,npz,newp,nedfr',i,npz,newp,nedfr(i)
        endif
        enddo
      endif
C
C   How many new edge couples satisfied ?
C        four in the general case in this case,
C         unless there was a border, then it will be 3
C                or a orner, then it will be 2
C
      iedges=0
      ibad=0
      call edges(nnxx,nnyy,iedges,ibad,ipuzn,ni,nz)
      nsum=nsum+iedges
C
C
C
      if(nsum.gt.nsumax)then
      do i=1,nxmax
      nis(i)=ni(i)
      enddo
      do i=1,npz
      nxs(i)=nx(i)
      nys(i)=ny(i)
      do j=1,4
      nzs(i,j)=nz(i,j)
      enddo
      enddo
      npzs=npz
      do i=1,nx1
      do j=1,nx2
      ipuzns(i,j)=ipuzn(i,j)
      enddo
      enddo
      nsumax=nsum
      bestm=nmove
C
C  Verbosity
C
      if(iverb.ge.1)then
      write(*,120)nsum,npz,iii,nmove
      write(10,120)nsum,npz,iii,nmove
      write(10,*)
      write(10,*)
      write(10,*)' Total number of placed pieces :',npzs
      write(10,*)
      write(10,*)' Table with all pieces :'
      write(10,*)
      write(10,*)'        1   2   3   4   5   6   7   8   9  10  11  12 
     1 13  14  15  16'
      write(10,*)
      do i=1,nx2
      write(10,288)i,(ipuzns(j,i),j=1,nx1)
      enddo
C
C  Final check on edges satisfied...
C
      iedges=0
      ibad=0
      call chekedge(iedges,ibad,ipuzns,nis,nzs)
      write(10,*)
      write(10,*)'  Shared edges :',iedges
      write(10,*)'  Bad edges    :',ibad
      write(10,*)
C
C
      endif
C
C  end verbosity
C
C
      endif
C
C
C   Go to select another edge to satisfy
C
      iplus=1
      go to 499
C
C
C
35    format(4i4)
121   format('   edges,...',i4,2x,i4,2x,i4,3x,4i4,2x,4i4)
288   format(i4,2x,16i4)
1111  format(2x,2i4,2x,4i4,2x,4i4)
1112  format(2x,2i4,2x,4i4,2x,4i4,' mierda !')
C
C
C
CCCC
C
C
C
C
C
C  last shells 7+8 + last holes elsewhere 
C       with permutations first between themselves
C
C
7002  continue
C
C
      if(npzs.lt.limref)go to 5001
      write(*,120)nsumax,npzs,iii,bestm,nout
      write(10,120)nsumax,npzs,iii,bestm,nout
C
C
      if(iverb.gt.0)then
C
      write(10,*)
      write(10,*)
      write(10,*)' Total number of placed pieces :',npzs
      write(10,*)
      write(10,*)' Table with all pieces :'
      write(10,*)
      write(10,*)'        1   2   3   4   5   6   7   8   9  10  11  12 
     1 13  14  15  16'
      write(10,*)
      do i=1,nx2
      write(10,288)i,(ipuzns(j,i),j=1,nx1)
      enddo
C
C  Final check on edges satisfied...
C
      iedges=0
      ibad=0
      call chekedge(iedges,ibad,ipuzns,nis,nzs)
      write(10,*)
      write(10,*)'  Shared edges :',iedges
      write(10,*)'  Bad edges    :',ibad
      write(10,*)
C
      endif
C
      do i=1,nxmax
      ni(i)=nis(i)
      enddo
      npz=npzs
      do i=1,npz
      nx(i)=nxs(i)
      ny(i)=nys(i)
      do j=1,4
      nz(i,j)=nzs(i,j)
      enddo
      enddo
      do i=1,nx1
      do j=1,nx2
      ipuzn(i,j)=ipuzns(i,j)
      enddo
      enddo
C
C  Did you win already ???
C
      if(ibad.eq.0.and.npzs.eq.nxmax)then
      ipr=1
      go to 4900
      endif
C
7003  continue
C
C
C   Reinit the complete series of pieces
C
      ifign0=nxmax
      do i=1,ifign0
      nnfig2(i)=i
      enddo
C
C   Remove the pieces already placed from the lists nnfig
C
      do k=1,npz
C
      jj=0
      do i=1,ifign0
      if(nnfig2(i).ne.ipuzn(nx(k),ny(k)))then
      jj=jj+1
      nnnfig2(jj)=nnfig2(i)
      endif
      enddo
C
      ifign0=jj
      do i=1,ifign0
      nnfig2(i)=nnnfig2(i)
      enddo
C
      enddo
C
C     count all new pieces
C
      numt=0
C
C
C Fill all the remaining holes
C
C
C  place 1,1 
C
      ii=1
      jj=1
      if(ipuzn(ii,jj).eq.0)then
      npz=npz+1
C
C  make the list of possibilities
C
      num=0
      do i=1,4
      if(nnfig2(i).le.4)then
      num=num+1
      mfig0(num)=nnfig2(i)
      endif
      enddo
C
C  choose randomly in the list
C
      new=int(float(num)*randi(iseed))+1
      if(new.gt.num)new=num
      newp=mfig0(new)
      numt=numt+1
      mfig0t(numt)=newp
C
      ipuzn(ii,jj)=newp
      ni(newp)=npz
      nx(npz)=ii
      ny(npz)=jj
C
C Find the rotation ir by locating where are the 0,0 figures
C
      do i=1,4
      if(np(newp,i).eq.0)then
      j=i+1
      if(j.eq.5)j=1
      if(np(newp,j).eq.0)go to 411
      endif
      enddo
C
411   continue
      if(i.eq.4.and.j.eq.1)ir=0
      if(i.eq.1.and.j.eq.2)ir=3
      if(i.eq.2.and.j.eq.3)ir=2
      if(i.eq.3.and.j.eq.4)ir=1
      ih=newp
      call rot(ih,npz,ir)
C
C   Remove the piece from the list nnfig2
C
      j=0
      do i=1,ifign0
      if(nnfig2(i).ne.ipuzn(nx(npz),ny(npz)))then
      j=j+1
      nnnfig2(j)=nnfig2(i)
      endif
      enddo
C
      ifign0=j
      do i=1,ifign0
      nnfig2(i)=nnnfig2(i)
      enddo
C
      endif
C
C  end of 1,1
C
C
C  place 1,nx2 
C
      ii=1
      jj=nx2
      if(ipuzn(ii,jj).eq.0)then
      npz=npz+1
C
C  make the list of possibilities
C
      num=0
      do i=1,4
      if(nnfig2(i).le.4)then
      num=num+1
      mfig0(num)=nnfig2(i)
      endif
      enddo
C
C  choose randomly in the list
C
      new=int(float(num)*randi(iseed))+1
      if(new.gt.num)new=num
      newp=mfig0(new)
      numt=numt+1
      mfig0t(numt)=newp
C
      ipuzn(ii,jj)=newp
      ni(newp)=npz
      nx(npz)=ii
      ny(npz)=jj
C
C Find the rotation ir by locating where are the 0,0 figures
C
      do i=1,4
      if(np(newp,i).eq.0)then
      j=i+1
      if(j.eq.5)j=1
      if(np(newp,j).eq.0)go to 412
      endif
      enddo
C
412   continue
      if(i.eq.4.and.j.eq.1)ir=3
      if(i.eq.1.and.j.eq.2)ir=2
      if(i.eq.2.and.j.eq.3)ir=1
      if(i.eq.3.and.j.eq.4)ir=0
      ih=newp
      call rot(ih,npz,ir)
C
C   Remove the piece from the list nnfig2
C
C
      j=0
      do i=1,ifign0
      if(nnfig2(i).ne.ipuzn(nx(npz),ny(npz)))then
      j=j+1
      nnnfig2(j)=nnfig2(i)
      endif
      enddo
C
      ifign0=j
      do i=1,ifign0
      nnfig2(i)=nnnfig2(i)
      enddo
C
      endif
C
C  end of 1,nx2
C
C
C  place nx1,1 
C
      ii=nx1
      jj=1
      if(ipuzn(ii,jj).eq.0)then
      npz=npz+1
C
C  make the list of possibilities
C
      num=0
      do i=1,4
      if(nnfig2(i).le.4)then
      num=num+1
      mfig0(num)=nnfig2(i)
      endif
      enddo
C
C  choose randomly in the list
C
      new=int(float(num)*randi(iseed))+1
      if(new.gt.num)new=num
      newp=mfig0(new)
      numt=numt+1
      mfig0t(numt)=newp
C
      ipuzn(ii,jj)=newp
      ni(newp)=npz
      nx(npz)=ii
      ny(npz)=jj
C
C Find the rotation ir by locating where are the 0,0 figures
C
      do i=1,4
      if(np(newp,i).eq.0)then
      j=i+1
      if(j.eq.5)j=1
      if(np(newp,j).eq.0)go to 403
      endif
      enddo
C
403   continue
      if(i.eq.4.and.j.eq.1)ir=1
      if(i.eq.1.and.j.eq.2)ir=0
      if(i.eq.2.and.j.eq.3)ir=3
      if(i.eq.3.and.j.eq.4)ir=2
      ih=newp
      call rot(ih,npz,ir)
C
C   Remove the piece from the list nnfig2
C
      j=0
      do i=1,ifign0
      if(nnfig2(i).ne.ipuzn(nx(npz),ny(npz)))then
      j=j+1
      nnnfig2(j)=nnfig2(i)
      endif
      enddo
C
      ifign0=j
      do i=1,ifign0
      nnfig2(i)=nnnfig2(i)
      enddo
C
      endif
C
C  end of nx1,1
C
C
C  place nx1,nx2
C
      ii=nx1
      jj=nx2
      if(ipuzn(ii,jj).eq.0)then
      npz=npz+1
C
C  make the list of possibilities
C
      num=0
      do i=1,4
      if(nnfig2(i).le.4)then
      num=num+1
      mfig0(num)=nnfig2(i)
      endif
      enddo
C
C  choose randomly in the list
C
      new=int(float(num)*randi(iseed))+1
      if(new.gt.num)new=num
      newp=mfig0(new)
      numt=numt+1
      mfig0t(numt)=newp
C
      ipuzn(ii,jj)=newp
      ni(newp)=npz
      nx(npz)=ii
      ny(npz)=jj
C
C Find the rotation ir by locating where are the 0,0 figures
C
      do i=1,4
      if(np(newp,i).eq.0)then
      j=i+1
      if(j.eq.5)j=1
      if(np(newp,j).eq.0)go to 404
      endif
      enddo
C
404   continue
      if(i.eq.4.and.j.eq.1)ir=1
      if(i.eq.1.and.j.eq.2)ir=0
      if(i.eq.2.and.j.eq.3)ir=3
      if(i.eq.3.and.j.eq.4)ir=2
      ih=newp
      call rot(ih,npz,ir)
C
C   Remove the piece from the list nnfig2
C
      j=0
      do i=1,ifign0
      if(nnfig2(i).ne.ipuzn(nx(npz),ny(npz)))then
      j=j+1
      nnnfig2(j)=nnfig2(i)
      endif
      enddo
C
      ifign0=j
      do i=1,ifign0
      nnfig2(i)=nnnfig2(i)
      enddo
C
      endif
C
C  end of nx1,nx2
C

C
C  border x=2 to nx3, y=1
C
      jj=1
      do ii=2,nx3
C
      if(ipuzn(ii,jj).eq.0)then
C
      npz=npz+1
C
C  make the list of possibilities
C
      num=0
      do i=1,nx5
      if(nnfig2(i).le.nx6)then
      num=num+1
      mfig0(num)=nnfig2(i)
      endif
      enddo
C
C  choose randomly in the list
C
      new=int(float(num)*randi(iseed))+1
      if(new.gt.num)new=num
      newp=mfig0(new)
      numt=numt+1
      mfig0t(numt)=newp
C
      ipuzn(ii,jj)=newp
      ni(newp)=npz
      nx(npz)=ii
      ny(npz)=jj
C
C Find the rotation ir by locating where are the 0,0 figures
C
      do i=1,4
      if(np(newp,i).eq.0)go to 501
      enddo
C
501   continue
      if(i.eq.1)ir=0
      if(i.eq.2)ir=3
      if(i.eq.3)ir=2
      if(i.eq.4)ir=1
      ih=newp
      call rot(ih,npz,ir)
C
C   Remove the piece from the list nnfig2
C
      j=0
      do i=1,ifign0
      if(nnfig2(i).ne.ipuzn(nx(npz),ny(npz)))then
      j=j+1
      nnnfig2(j)=nnfig2(i)
      endif
      enddo
C
      ifign0=j
      do i=1,ifign0
      nnfig2(i)=nnnfig2(i)
      enddo
C
      endif
C
      enddo
C
C  end of border x=2 to nx2, y=1
C
C
C  border x=1 , y=2 to nx4
C
      ii=1
      do jj=2,nx4
C
      if(ipuzn(ii,jj).eq.0)then
C
      npz=npz+1
C
C  make the list of possibilities
C
      num=0
      do i=1,nx5
      if(nnfig2(i).le.nx6)then
      num=num+1
      mfig0(num)=nnfig2(i)
      endif
      enddo
C
C  choose randomly in the list
C
      new=int(float(num)*randi(iseed))+1
      if(new.gt.num)new=num
      newp=mfig0(new)
      numt=numt+1
      mfig0t(numt)=newp
C
      ipuzn(ii,jj)=newp
      ni(newp)=npz
      nx(npz)=ii
      ny(npz)=jj
C
C Find the rotation ir by locating where are the 0,0 figures
C
      do i=1,4
      if(np(newp,i).eq.0)go to 502
      enddo
C
502   continue
      if(i.eq.1)ir=3
      if(i.eq.2)ir=2
      if(i.eq.3)ir=1
      if(i.eq.4)ir=0
      ih=newp
      call rot(ih,npz,ir)
C
C   Remove the piece from the list nnfig2
C
      j=0
      do i=1,ifign0
      if(nnfig2(i).ne.ipuzn(nx(npz),ny(npz)))then
      j=j+1
      nnnfig2(j)=nnfig2(i)
      endif
      enddo
C
      ifign0=j
      do i=1,ifign0
      nnfig2(i)=nnnfig2(i)
      enddo
C
      endif
C
      enddo
C
C  end of border x=1 , y=2 to nx4
C
C
C  border x=nx1 , y=2 to nx4
C
      ii=nx1
      do jj=2,nx4
C
      if(ipuzn(ii,jj).eq.0)then
C
      npz=npz+1
C
C  make the list of possibilities
C
      num=0
      do i=1,nx5
      if(nnfig2(i).le.nx6)then
      num=num+1
      mfig0(num)=nnfig2(i)
      endif
      enddo
C
C  choose randomly in the list
C
      new=int(float(num)*randi(iseed))+1
      if(new.gt.num)new=num
      newp=mfig0(new)
      numt=numt+1
      mfig0t(numt)=newp
C
      ipuzn(ii,jj)=newp
      ni(newp)=npz
      nx(npz)=ii
      ny(npz)=jj
C
C Find the rotation ir by locating where are the 0,0 figures
C
      do i=1,4
      if(np(newp,i).eq.0)go to 503
      enddo
C
503   continue
      if(i.eq.1)ir=1
      if(i.eq.2)ir=0
      if(i.eq.3)ir=3
      if(i.eq.4)ir=2
      ih=newp
      call rot(ih,npz,ir)
C
C   Remove the piece from the list nnfig2
C
      j=0
      do i=1,ifign0
      if(nnfig2(i).ne.ipuzn(nx(npz),ny(npz)))then
      j=j+1
      nnnfig2(j)=nnfig2(i)
      endif
      enddo
C
      ifign0=j
      do i=1,ifign0
      nnfig2(i)=nnnfig2(i)
      enddo
C
      endif
C
      enddo
C
C  end of border x=nx1 , y=2 to nx4
C
C
C  border x=2 to nx3 , y=nx2
C
      jj=nx2
      do ii=2,nx3
C
      if(ipuzn(ii,jj).eq.0)then
C
      npz=npz+1
C
C  make the list of possibilities
C
      num=0
      do i=1,nx5
      if(nnfig2(i).le.nx6)then
      num=num+1
      mfig0(num)=nnfig2(i)
      endif
      enddo
C
C  choose randomly in the list
C
      new=int(float(num)*randi(iseed))+1
      if(new.gt.num)new=num
      newp=mfig0(new)
      numt=numt+1
      mfig0t(numt)=newp
C
      ipuzn(ii,jj)=newp
      ni(newp)=npz
      nx(npz)=ii
      ny(npz)=jj
C
C Find the rotation ir by locating where are the 0,0 figures
C
      do i=1,4
      if(np(newp,i).eq.0)go to 504
      enddo
C
504   continue
      if(i.eq.1)ir=2
      if(i.eq.2)ir=1
      if(i.eq.3)ir=0
      if(i.eq.4)ir=3
      ih=newp
      call rot(ih,npz,ir)
C
C   Remove the piece from the list nnfig2
C
      j=0
      do i=1,ifign0
      if(nnfig2(i).ne.ipuzn(nx(npz),ny(npz)))then
      j=j+1
      nnnfig2(j)=nnfig2(i)
      endif
      enddo
C
      ifign0=j
      do i=1,ifign0
      nnfig2(i)=nnnfig2(i)
      enddo
C
      endif
C
      enddo
C
C  end of border x=2 to nx3 , y=nx2
C
C
C  center x=2 to nx3 , y=2 to nx4
C
      num=0
C
      do ii=2,nx3
      do jj=2,nx4
      if(ipuzn(ii,jj).eq.0)then
C
C
      npz=npz+1
C
C  choose randomly in the remaining list
C
      new=int(float(ifign0)*randi(iseed))+1
      if(new.gt.ifign0)new=ifign0
      newp=nnfig2(new)
C
      ipuzn(ii,jj)=newp
      ni(newp)=npz
      nx(npz)=ii
      ny(npz)=jj
C
C  make the first list 
C
      num=num+1
      numt=numt+1
      mfig0(num)=newp
      mfig0t(numt)=newp
C
C decide the rotation at random
C
C
C decide the rotation at random
C
      ir=int(4.*randi(iseed))+1
      if(ir.gt.4)ir=4
      ir=ir-1
      ih=newp
      call rot(ih,npz,ir)
C
C   Remove the piece from the list nnfig
C
      j=0
      do i=1,ifign0
      if(nnfig2(i).ne.ipuzn(nx(npz),ny(npz)))then
      j=j+1
      nnnfig2(j)=nnfig2(i)
      endif
      enddo
C
      ifign0=j
      do i=1,ifign0
      nnfig2(i)=nnnfig2(i)
      enddo
C
      endif
      enddo
      enddo
C
C  end of center x=2 to nx3 , y=2 to nx4
C
C
      if(iverb.gt.0)then
C
      write(10,*)
      write(10,*)
      write(10,*)' Total number of placed pieces :',npz
      write(10,*)
      write(10,*)' Table with all pieces :'
      write(10,*)
      write(10,*)'        1   2   3   4   5   6   7   8   9  10  11  12 
     1 13  14  15  16'
      write(10,*)
      do i=1,nx2
      write(10,288)i,(ipuzn(j,i),j=1,nx1)
      enddo
C
      endif
C
C
C
C  Verify if we have won by chance... ;-)
C
      iedges=0
      ibad=0
      call chekedge(iedges,ibad,ipuzn,ni,nz)
      ntotedge=iedges+ibad
C
      if(iverb.gt.0)then
      write(10,*)
      write(10,*)'  Shared edges :',iedges
      write(10,*)'  Bad edges    :',ibad
      write(10,*)
      endif
C
	nsum=iedges
C
C
      if(icalc0.gt.0)go to 7001
C
      ntot=numt
C
C
      do i=1,nxmax
      do j=1,4
      nzn(i,j)=nz(i,j)
      enddo
      enddo
C
C
C
      nmovemax=ntot*200000.
      nmove=0.
C
C
C
C       The true big loop is there...........
C  
C
C
5799  continue
      nmove=nmove+1.
C
C
      damp=damp0*(nmovemax-nmove)/nmovemax
      if(nmove.ge.nmovemax)go to 7008
C
C   Select randomly one piece (hints excluded)
C
C
C
C
      new=int(float(ntot)*randi(iseed))+1
      if(new.gt.ntot)new=ntot
      newp=mfig0t(new)
      newp1=newp
C
C get npz
C
      n=ni(newp)
C
C
C  Coordinates
C
      i=nx(n)
      j=ny(n)
      i1=i
      j1=j
C
C  Check if not already perfect
C
      ibad=0
      call nedges(i,j,ibad,nz)
      if(ibad.eq.0)then
      go to 5799
      endif
C
C  Rotations and/or permutations are possible 
C          if the piece is not border
C                 i or j different from 1 or nx1,nx2
C
C
      if(i.ne.1.and.j.ne.1.and.i.ne.nx1.and.j.ne.nx2)then
C
C  prop decides for the proportion of pure
C  rotation (nrp=2) or permutation+rotation (nrp=1)
C
C      if prop = 1 : 100% permutations
C      if prop = 0.5 : 50% permutations 50% rotations
C
C  However, pure rotation is not possible at the border, of course
C
      xnrp=randi(iseed)
      if(xnrp.lt.prop)nrp=1
      if(xnrp.ge.prop)nrp=2
C
C
      if(nrp.eq.1)then
C
C  Permutation
C
C  then select a second piece not on the border
C
      iloop=0
4010  new=int(float(ntot)*randi(iseed))+1
      if(new.gt.ntot)new=ntot
      newp=mfig0t(new)
      newp2=newp
C
C get npz
C
      n2=ni(newp)
C
C
C  Coordinates
C
      i2=nx(n2)
      j2=ny(n2)
      if(ipuzn(i2,j2).le.nx6)go to 4010
      ir1=0
      ir2=0
C
C  detect infinite loop 1 
C
      iloop=iloop+1
      if(iloop.gt.1000)then
      write(10,*)
      write(10,*)'infinite loop 1-1...',i,j,i2,j2
      write(*,*)'infinite loop 1-1...',i,j,i2,j2
      write(10,*)
      go to 5001
      endif
C
C  Check if not already perfect
C
      ibad2=0
      call nedges(i2,j2,ibad2,nz)
C      if(ibad2.eq.0)then
C      go to 4010
C      endif
C
C  Avoid same piece
C
      if(n.eq.n2)go to 4010
C
C  detect immediate neighbours
C
      nibad=0
      if(i.eq.i2.and.iabs(j2-j).eq.1)nibad=1
      if(j.eq.j2.and.iabs(i2-i).eq.1)nibad=1
C
C  Calculate old ibad
C
C
C  Case nibad=1
C
      if(nibad.eq.1)then
      ibadt1=0
      call edges2(i,j,i2,j2,ibadt1,nz)
      else
      ibadt1=ibad+ibad2
      endif
C
C  Memorize
C
      newp1=ipuzn(i,j)
      ni1=ni(newp1)
      do ij=1,4
      nb1(ij)=nz(n,ij)
      enddo
      newp2=ipuzn(i2,j2)
      ni2=ni(newp2)
      do ij=1,4
      nb2(ij)=nz(n2,ij)
      enddo
C
C  Permute
C
      ipuzn(i,j)=newp2
      ipuzn(i2,j2)=newp1
      ni(newp2)=ni1
      ni(newp1)=ni2
      do ij=1,4
      nz(n,ij)=nb2(ij)
      nz(n2,ij)=nb1(ij)
      enddo
C
C decide for the best rotations 0, 1, 2 or 3 for n, i, j
C
      imin=10
      ibest=1
      do nj=1,4
      ir=nj-1
      call rotb(n,ir,nz,nzn)
      do ij=1,4
      nsa(nj,ij)=nzn(n,ij)
      nz(n,ij)=nzn(n,ij)
      enddo
C
C mark the best
C
      ibad=0
      call nedges(i,j,ibad,nz)
      if(ibad.lt.imin)then
          imin=ibad
          ibest=nj
      endif
      enddo
C
      do ij=1,4
      nz(n,ij)=nsa(ibest,ij)
      enddo
C
C decide for the best rotations 0, 1, 2 or 3 for n2, i2, j2
C
      imin=10
      ibest=1
      do nj=1,4
      ir=nj-1
      call rotb(n2,ir,nz,nzn)
      do ij=1,4
      nsa(nj,ij)=nzn(n2,ij)
      nz(n2,ij)=nzn(n2,ij)
      enddo
C
C mark the best
C
      ibad=0
      call nedges(i2,j2,ibad,nz)
      if(ibad.lt.imin)then
          imin=ibad
          ibest=nj
      endif
      enddo
      do ij=1,4
      nz(n2,ij)=nsa(ibest,ij)
      enddo
C
C  Compute new ibad
C
C
C  Case nibad=1
C
      if(nibad.eq.1)then
      ibadt2=0
      call edges2(i,j,i2,j2,ibadt2,nz)
      else
      ibad3=0
      call nedges(i,j,ibad3,nz)
      ibad4=0
      call nedges(i2,j2,ibad4,nz)
      ibadt2=ibad3+ibad4
      endif
C
C
      nallow=0
      if(randi(iseed).le.damp)nallow=1
      if(ibadt2.le.ibadt1)nallow=1
C
C  Check and permute or go back
C
      if(nallow.eq.1)then
      nsum=nsum+ibadt1-ibadt2
      else
C
C  rechange
C
      ipuzn(i,j)=newp1
      ipuzn(i2,j2)=newp2
      ni(newp2)=ni2
      ni(newp1)=ni1
      do ij=1,4
      nz(n,ij)=nb1(ij)
      nz(n2,ij)=nb2(ij)
      enddo
	endif
C
C
C
      endif
C
C
C
      if(nrp.eq.2)then
C
C  Rotation
C
      ibadt1=ibad
C
C memorize
C
      do ij=1,4
      nbm(ij)=nz(n,ij)
      nsa(1,ij)=nbm(ij)
      enddo
C
C decide for the best rotations 1, 2 or 3 for n, i, j
C
      imin=ibadt1
      ibest=1
      do nj=2,4
      njr=nj-1
      call rotb(n,njr,nz,nzn)
      do ij=1,4
      nsa(nj,ij)=nzn(n,ij)
      nz(n,ij)=nzn(n,ij)
      enddo
C
C mark the best
C
      ibad=0
      call nedges(i,j,ibad,nz)
      if(ibad.lt.imin)then
          imin=ibad
          ibest=nj
      endif
      enddo
      do ij=1,4
      nz(n,ij)=nsa(ibest,ij)
      enddo
C
C  Compute new iedges
C
      ibadt2=0
      call nedges(i,j,ibadt2,nz)
      nallow=0
      if(randi(iseed).le.damp)nallow=1
      if(ibadt2.le.ibadt1)nallow=1
C
C  Check and permute or go back
C
C
C  Check and permute or go back
C
      if(nallow.eq.1)then
      nsum=nsum+ibadt1-ibadt2
      else
      do ij=1,4
      nz(n,ij)=nbm(ij)
      enddo
	endif
C
      endif
C
C
      else
C
C
C
C
C  For the border, permutation + forced rotation
C                 i or j = 1 or nx1,nx2
C
C
C  Permutation + forced rotation
C
C  then select a second piece on the border
C
C  general case
C
      ntot5=nx5
      if(i.eq.1.and.j.eq.1)ntot5=4
      if(i.eq.1.and.j.eq.nx2)ntot5=4
      if(i.eq.nx1.and.j.eq.nx2)ntot5=4
      if(i.eq.nx1.and.j.eq.1)ntot5=4
      iloop=0
900   new=int(float(ntot)*randi(iseed))+1
      if(new.gt.ntot)new=ntot
      newp=mfig0t(new)
      newp2=newp
C
C get npz
C
      n2=ni(newp)
C
C   cannot be two times the same piece
C
      if(n.eq.n2)go to 900
C
C
C  Coordinates
C
      i2=nx(n2)
      j2=ny(n2)
C
C  detect infinite loop on the border 1
C
      iloop=iloop+1
      if(iloop.gt.1000)then
C      write(10,*)
C      write(10,*)'infinite loop on the border 1-1...',i,j,i2,j2
C      write(*,*)'infinite loop on the border 1-1...',i,j,i2,j2
C      write(10,*)
      go to 5799
      endif
C
C
      if(ntot5.eq.4)then
      if(i2.eq.1.and.j2.eq.1)go to 912
      if(i2.eq.1.and.j2.eq.nx2)go to 912
      if(i2.eq.nx1.and.j2.eq.nx2)go to 912
      if(i2.eq.nx1.and.j2.eq.1)go to 912
      go to 900
      endif
      if(ntot5.eq.nx5)then
      if(i2.eq.1.and.j2.eq.1)go to 900
      if(i2.eq.1.and.j2.eq.nx2)go to 900
      if(i2.eq.nx1.and.j2.eq.nx2)go to 900
      if(i2.eq.nx1.and.j2.eq.1)go to 900
      if(i2.eq.1.or.j2.eq.1.or.i2.eq.nx1.or.j2.eq.nx2)go to 912
      go to 900
      endif
912   continue
C
C  Check if not already perfect
C
      ibad2=0
      call nedges(i2,j2,ibad2,nz)
C      if(ibad2.eq.0)then
C      go to 900
C      endif
C
C  detect immediate neighbours
C
      nibad=0
      if(i.eq.i2.and.iabs(j2-j).eq.1)nibad=1
      if(j.eq.j2.and.iabs(i2-i).eq.1)nibad=1
C
C  Calculate old ibad
C
C
C  Case nibad=1
C
      if(nibad.eq.1)then
      ibadt1=0
      call edges2(i,j,i2,j2,ibadt1,nz)
      else
      ibadt1=ibad+ibad2
      endif
C
C  Memorize
C
      newp1=ipuzn(i,j)
      ni1=ni(newp1)
      do ij=1,4
      nb1(ij)=nz(n,ij)
      enddo
      newp2=ipuzn(i2,j2)
      ni2=ni(newp2)
      do ij=1,4
      nb2(ij)=nz(n2,ij)
      enddo
C
C  Permute
C
      ipuzn(i,j)=newp2
      ipuzn(i2,j2)=newp1
      ni(newp2)=ni1
      ni(newp1)=ni2
C
C   Forced rotation
C
C
C  Case  1,1   nx1,1 or vice versa
C
      if(i.eq.1.and.j.eq.1.and.i2.eq.nx1.and.j2.eq.1)then
      ir1=1
      ir2=3
      go to 730
      endif
      if(i.eq.nx1.and.j.eq.1.and.i2.eq.1.and.j2.eq.1)then
      ir1=3
      ir2=1
      go to 730
      endif
C
C  Case  1,1   1,nx2 or vice versa
C
      if(i.eq.1.and.j.eq.1.and.i2.eq.1.and.j2.eq.nx2)then
      ir1=3
      ir2=1
      go to 730
      endif
      if(i.eq.1.and.j.eq.nx2.and.i2.eq.1.and.j2.eq.1)then
      ir1=1
      ir2=3
      go to 730
      endif
C
C  Case  1,1   nx1,nx2 or vice versa
C
      if(i.eq.1.and.j.eq.1.and.i2.eq.nx1.and.j2.eq.nx2)then
      ir1=2
      ir2=2
      go to 730
      endif
      if(i.eq.nx1.and.j.eq.nx2.and.i2.eq.1.and.j2.eq.1)then
      ir1=2
      ir2=2
      go to 730
      endif
C
C  Case  nx1,1   nx1,nx2 or vice versa
C
      if(i.eq.nx1.and.j.eq.1.and.i2.eq.nx1.and.j2.eq.nx2)then
      ir1=1
      ir2=3
      go to 730
      endif
      if(i.eq.nx1.and.j.eq.nx2.and.i2.eq.nx1.and.j2.eq.1)then
      ir1=3
      ir2=1
      go to 730
      endif
C
C  Case  nx1,1   1,nx2 or vice versa
C
      if(i.eq.nx1.and.j.eq.1.and.i2.eq.1.and.j2.eq.nx2)then
      ir1=2
      ir2=2
      go to 730
      endif
      if(i.eq.1.and.j.eq.nx2.and.i2.eq.nx1.and.j2.eq.1)then
      ir1=2
      ir2=2
      go to 730
      endif
C
C  Case  1,nx2   nx1,nx2 or vice versa
C
      if(i.eq.1.and.j.eq.nx2.and.i2.eq.nx1.and.j2.eq.nx2)then
      ir1=3
      ir2=1
      go to 730
      endif
      if(i.eq.nx1.and.j.eq.nx2.and.i2.eq.1.and.j2.eq.nx2)then
      ir1=1
      ir2=3
      go to 730
      endif
C
C  but if y=1 or y = nx2 or x = 1 or x = nx1 for both pieces
C           then there is no rotation...
C
      if(i.eq.1.and.i2.eq.1)go to 731
      if(i.eq.nx1.and.i2.eq.nx1)go to 731
      if(j.eq.1.and.j2.eq.1)go to 731
      if(j.eq.nx2.and.j2.eq.nx2)go to 731
C
C  Case x1=1,y2=1  or x2=1 y1=1
C
      if(i.eq.1.and.j2.eq.1)then
      ir1=1
      ir2=3
      go to 730
      endif
      if(i2.eq.1.and.j.eq.1)then
      ir1=3
      ir2=1
      go to 730
      endif
C
C  Case x1=1,y2=nx2  or x2=1 y1=nx2
C
      if(i.eq.1.and.j2.eq.nx2)then
      ir1=3
      ir2=1
      go to 730
      endif
      if(i2.eq.1.and.j.eq.nx2)then
      ir1=1
      ir2=3
      go to 730
      endif
C
C  Case x1=1,x2=nx1 or x1=nx1 x2=1
C
      if(i.eq.1.and.i2.eq.nx1)then
      ir1=2
      ir2=2
      go to 730
      endif
      if(i.eq.nx1.and.i2.eq.1)then
      ir1=2
      ir2=2
      go to 730
      endif
C
C  Case x1=nx1,y2=1 or x2=nx1 y1=1
C
      if(i.eq.nx1.and.j2.eq.1)then
      ir1=3
      ir2=1
      go to 730
      endif
      if(i2.eq.nx1.and.j.eq.1)then
      ir1=1
      ir2=3
      go to 730
      endif
C
C  Case x1=nx1,y2=nx2 or x2=nx1 y1=nx2
C
      if(i.eq.nx1.and.j2.eq.nx2)then
      ir1=1
      ir2=3
      go to 730
      endif
      if(j.eq.nx2.and.i2.eq.nx1)then
      ir1=3
      ir2=1
      go to 730
      endif
C
C  Case y1=1,y2=nx2 or y2=1 y1=nx2
C
      if(j.eq.1.and.j2.eq.nx2)then
      ir1=2
      ir2=2
      go to 730
      endif
      if(j2.eq.1.and.j.eq.nx2)then
      ir1=2
      ir2=2
      go to 730
      endif
C
731   continue
C
C  permute without rotation
C
      do ij=1,4
      nz(n,ij)=nb2(ij)
      nz(n2,ij)=nb1(ij)
      nzn(n,ij)=nb2(ij)
      nzn(n2,ij)=nb1(ij)
      enddo
      go to 732
C
C  rotate, then permute
C
730   call rotb(n,ir1,nz,nzn)
      do ij=1,4
      nb3(ij)=nzn(n,ij)
      enddo
      call rotb(n2,ir2,nz,nzn)
      do ij=1,4
      nb4(ij)=nzn(n2,ij)
      enddo
      do ij=1,4
      nz(n,ij)=nb4(ij)
      nz(n2,ij)=nb3(ij)
      nzn(n,ij)=nb4(ij)
      nzn(n2,ij)=nb3(ij)
      enddo
732   continue
C
C  Compute new iedges
C
C
C  Case nibad=1
C
      if(nibad.eq.1)then
      ibadt2=0
      call edges2(i,j,i2,j2,ibadt2,nz)
      else
      ibad3=0
      call nedges(i,j,ibad3,nz)
      ibad4=0
      call nedges(i2,j2,ibad4,nz)
      ibadt2=ibad3+ibad4
      endif
C
      nallow=0
      if(randi(iseed).le.damp)nallow=1
      if(ibadt2.le.ibadt1)nallow=1
C
C  Check and permute or go back
C
      if(nallow.eq.1)then
      nsum=nsum+ibadt1-ibadt2
      else
C
C  rechange
C
      ipuzn(i,j)=newp1
      ipuzn(i2,j2)=newp2
      ni(newp2)=ni2
      ni(newp1)=ni1
      do ij=1,4
      nz(n,ij)=nb1(ij)
      nz(n2,ij)=nb2(ij)
      nzn(n,ij)=nb1(ij)
      nzn(n2,ij)=nb2(ij)
      enddo
	endif
C
C
C
      endif
C
C

C
C
C
C
C
C
C
C
      if(nsum.gt.nsumax2)then
      do i=1,nxmax
      nis(i)=ni(i)
      enddo
      do i=1,npz
      nxs(i)=nx(i)
      nys(i)=ny(i)
      do j=1,4
      nzs(i,j)=nz(i,j)
      enddo
      enddo
      npzs=npz
      do i=1,nx1
      do j=1,nx2
      ipuzns(i,j)=ipuzn(i,j)
      enddo
      enddo
      iedges=0
      ibad=0
      call chekedge(iedges,ibad,ipuzns,nis,nzs)
      nsum=iedges
      nsumax2=nsum
      if(nsumax2.gt.nsumax3)nsumax3=nsumax2
C
C  Verbosity
C
      if(iverb.ge.2)then
      write(*,120)nsum,npz,iii,nmove
      write(10,120)nsum,npz,iii,nmove
      write(10,*)
      write(10,*)
      write(10,*)' Total number of placed pieces :',npzs
      write(10,*)
      write(10,*)' Table with all pieces :'
      write(10,*)
      write(10,*)'        1   2   3   4   5   6   7   8   9  10  11  12 
     1 13  14  15  16'
      write(10,*)
      do i=1,nx2
      write(10,288)i,(ipuzns(j,i),j=1,nx1)
      enddo
C
C  Final check on edges satisfied...
C
      iedges=0
      ibad=0
      call chekedge(iedges,ibad,ipuzns,nis,nzs)
      write(10,*)
      write(10,*)'  Shared edges :',iedges
      write(10,*)'  Bad edges    :',ibad
      write(10,*)
C
C
      endif
C
C  end verbosity
C
C

      endif
C
C
C
C
      go to 5799
C
C
7008  continue
C
C
      write(*,121)nsumax2,iii
      write(10,121)nsumax2,iii
C
      if(iverb.gt.0)then
C
      write(10,*)
      write(10,*)
      write(10,*)' Total number of placed pieces :',npz
      write(10,*)
      write(10,*)' Table with all pieces :'
      write(10,*)
      write(10,*)'        1   2   3   4   5   6   7   8   9  10  11  12 
     1 13  14  15  16'
      write(10,*)
      do i=1,nx2
      write(10,288)i,(ipuzn(j,i),j=1,nx1)
      enddo
C
C  Final check on edges satisfied...
C
      iedges=0
      ibad=0
      call chekedge(iedges,ibad,ipuzn,ni,nz)
      write(10,*)
      write(10,*)'  Shared edges :',iedges
      write(10,*)'  Bad edges    :',ibad
      write(10,*)
C
      endif
C
C
7001  continue
C
C  Now permute everything 
C
C
C
C   Decide randomly for permutations and/or rotations
C
      ntot=nxmax-npz0
C
      do i=1,nxmax
      do j=1,4
      nzn(i,j)=nz(i,j)
      enddo
      enddo
C
C
C
      nmovemax=ntot*200000.
      if(icalc0.gt.0)nmovemax=nmovemax0
      nmove=0.
      icalc1=1
      if(icalc0.gt.1)icalc1=icalc0
      icalc=1
C
C
C
C       The true big permutation loop is there...........
C  
C
C
5499  continue
C
C
      xdamp=(nmovemax-nmove)/nmovemax
      damp=damp0*xdamp
      if(icalc0.gt.1)then
      icalc=int(float(icalc1)*randi(iseed)*xdamp)+1
      if(icalc.gt.icalc1)icalc=icalc1
      endif
C
C  Make icalc moves before to decide if they will be
C              kept or not..
C
C
C
C  but before, memorize all
C
      do i=1,nxmax
      niold(i)=ni(i)
      enddo
      do i=1,npz
      do j=1,4
      nzold(i,j)=nz(i,j)
      enddo
      enddo
      do i=1,nx1
      do j=1,nx2
      ipuzold(i,j)=ipuzn(i,j)
      enddo
      enddo
C
C
      nsum0=nsum
C
C   icalc moves
C
C
      do 6500 im=1,icalc
C
5497  nmove=nmove+1.
      if(nmove.ge.nmovemax)go to 4998
C
C   Select randomly one piece (hints excluded)
C
      n=int(float(ntot)*randi(iseed))+1
      if(n.gt.ntot)n=ntot
      n=n+npz0
C
C  Check if not already made in the loop 6500
C
      n1mem(im)=n
      if(im.ge.2)then
      do imem=1,im-1
      if(n.eq.n1mem(imem))go to 5497
      enddo
      endif
C
C
      nrp=1
C
C
C  Coordinates
C
      i=nx(n)
      j=ny(n)
      i1=i
      j1=j
C
C  Check if not already perfect
C
      ibad=0
      call nedges(i,j,ibad,nz)
      if(ibad.eq.0)then
      go to 5497
      endif
C
C  Rotations and/or permutations are possible 
C          if the piece is not border
C                 i or j different from 1 or nx1, nx2
C
C
      if(i.ne.1.and.j.ne.1.and.i.ne.nx1.and.j.ne.nx2)then
C
C  prop decides for the proportion of pure
C  rotation (nrp=2) or permutation+rotation (nrp=1)
C
C      if prop = 1 : 100% permutations
C      if prop = 0.5 : 50% permutations 50% rotations
C
C  However, pure rotation is not possible at the border, of course
C
      xnrp=randi(iseed)
      if(xnrp.lt.prop)nrp=1
      if(xnrp.ge.prop)nrp=2
C
C
      if(nrp.eq.1)then
C
C  Permutation
C
C  then select a second piece not on the border
C
      iloop=0
5010  n2=int(float(ntot)*randi(iseed))+1
      if(n2.gt.ntot)n2=ntot
      n2=n2+npz0
      n2mem(im)=n2
C
C  Check if not already made in the loop 6500
C
      if(im.ge.2)then
      do imem=1,im-1
      if(n2.eq.n2mem(imem))go to 5010
      enddo
      endif
C
      i2=nx(n2)
      j2=ny(n2)
      if(ipuzn(i2,j2).le.nx6)go to 5010
      ir1=0
      ir2=0
C
C  detect infinite loop 1 
C
      iloop=iloop+1
      if(iloop.gt.1000)then
      write(10,*)
      write(10,*)'infinite loop 1-2...',i,j,i2,j2
      write(*,*)'infinite loop 1-2...',i,j,i2,j2
      write(10,*)
      go to 5001
      endif
C
C  Check if not already perfect
C
      ibad2=0
      call nedges(i2,j2,ibad2,nz)
C      if(ibad2.eq.0)then
C      go to 5010
C      endif
C
C  Avoid same piece
C
      if(n.eq.n2)go to 5010
C
C  detect immediate neighbours
C
      nibad=0
      if(i.eq.i2.and.iabs(j2-j).eq.1)nibad=1
      if(j.eq.j2.and.iabs(i2-i).eq.1)nibad=1
C
C  Calculate old ibad
C
C
C  Case nibad=1
C
      if(nibad.eq.1)then
      ibadt1=0
      call edges2(i,j,i2,j2,ibadt1,nz)
      else
      ibadt1=ibad+ibad2
      endif
C
C  Memorize
C
      nrpm(im)=nrp
      newpm1(im)=ipuzn(i,j)
      nim1(im)=ni(newpm1(im))
      do ij=1,4
      nbm1(im,ij)=nz(n,ij)
      enddo
      newpm2(im)=ipuzn(i2,j2)
      nim2(im)=ni(newpm2(im))
      do ij=1,4
      nbm2(im,ij)=nz(n2,ij)
      enddo
C
C  Permute
C
      ipuzn(i,j)=newpm2(im)
      ipuzn(i2,j2)=newpm1(im)
      ni(newpm2(im))=nim1(im)
      ni(newpm1(im))=nim2(im)
      do ij=1,4
      nz(n,ij)=nbm2(im,ij)
      nz(n2,ij)=nbm1(im,ij)
      enddo
C
C decide for the best rotations 0, 1, 2 or 3 for n, i, j
C
      imin=10
      ibest=1
      do nj=1,4
      ir=nj-1
      call rotb(n,ir,nz,nzn)
      do ij=1,4
      nsa(nj,ij)=nzn(n,ij)
      nz(n,ij)=nzn(n,ij)
      enddo
C
C mark the best
C
      ibad=0
      call nedges(i,j,ibad,nz)
      if(ibad.lt.imin)then
          imin=ibad
          ibest=nj
      endif
      enddo
C
      do ij=1,4
      nz(n,ij)=nsa(ibest,ij)
      enddo
C
C decide for the best rotations 0, 1, 2 or 3 for n2, i2, j2
C
      imin=10
      ibest=1
      do nj=1,4
      ir=nj-1
      call rotb(n2,ir,nz,nzn)
      do ij=1,4
      nsa(nj,ij)=nzn(n2,ij)
      nz(n2,ij)=nzn(n2,ij)
      enddo
C
C mark the best
C
      ibad=0
      call nedges(i2,j2,ibad,nz)
      if(ibad.lt.imin)then
          imin=ibad
          ibest=nj
      endif
      enddo
      do ij=1,4
      nz(n2,ij)=nsa(ibest,ij)
      enddo
C
C  Compute new ibad
C
C
C  Case nibad=1
C
      if(nibad.eq.1)then
      ibadt2=0
      call edges2(i,j,i2,j2,ibadt2,nz)
      else
      ibad3=0
      call nedges(i,j,ibad3,nz)
      ibad4=0
      call nedges(i2,j2,ibad4,nz)
      ibadt2=ibad3+ibad4
      endif
C
C
      nsum=nsum+ibadt1-ibadt2
      if(nsum.eq.ntotedge)go to 4996
C
C
C
      endif
C
C
C
      if(nrp.eq.2)then
C
C  Rotation
C
      ibadt1=ibad
C
C memorize
C
      nrpm(im)=nrp
      do ij=1,4
      nbm1(im,ij)=nz(n,ij)
      nsa(1,ij)=nbm1(im,ij)
      enddo
C
C decide for the best rotations 1, 2 or 3 for n, i, j
C
      imin=ibadt1
      ibest=1
      do nj=2,4
      njr=nj-1
      call rotb(n,njr,nz,nzn)
      do ij=1,4
      nsa(nj,ij)=nzn(n,ij)
      nz(n,ij)=nzn(n,ij)
      enddo
C
C mark the best
C
      ibad=0
      call nedges(i,j,ibad,nz)
      if(ibad.lt.imin)then
          imin=ibad
          ibest=nj
      endif
      enddo
      do ij=1,4
      nz(n,ij)=nsa(ibest,ij)
      enddo
C
C  Compute new iedges
C
      ibadt2=0
      call nedges(i,j,ibadt2,nz)
      nsum=nsum+ibadt1-ibadt2
      if(nsum.eq.ntotedge)go to 4996
C
      endif
C
C
      else
C
C
C
C
C  For the border, permutation + forced rotation
C                 i or j = 1 or nx1, nx2
C
C
C  Permutation + forced rotation
C
C  then select a second piece on the border
C
C  general case
C
      ntot5=nx5
      if(i.eq.1.and.j.eq.1)ntot5=4
      if(i.eq.1.and.j.eq.nx2)ntot5=4
      if(i.eq.nx1.and.j.eq.nx2)ntot5=4
      if(i.eq.nx1.and.j.eq.1)ntot5=4
      iloop=0
600   n2=int(float(ntot)*randi(iseed))+1
      if(n2.gt.ntot)n2=ntot
      n2=n2+npz0
      n2mem(im)=n2
C
C   cannot be two times the same piece
C
      if(n.eq.n2)go to 600
      i2=nx(n2)
      j2=ny(n2)
C
C  detect infinite loop on the border 1
C
      iloop=iloop+1
      if(iloop.gt.1000)then
C      write(10,*)
C      write(10,*)'infinite loop on the border 1-2...',i,j,i2,j2
C      write(*,*)'infinite loop on the border 1-2...',i,j,i2,j2
C      write(10,*)
      go to 5497
      endif
C
      if(ntot5.eq.4)then
      if(i2.eq.1.and.j2.eq.1)go to 612
      if(i2.eq.1.and.j2.eq.nx2)go to 612
      if(i2.eq.nx1.and.j2.eq.nx2)go to 612
      if(i2.eq.nx1.and.j2.eq.nx2)go to 612
      go to 600
      endif
      if(ntot5.eq.nx5)then
      if(i2.eq.1.and.j2.eq.1)go to 600
      if(i2.eq.1.and.j2.eq.nx2)go to 600
      if(i2.eq.nx1.and.j2.eq.nx2)go to 600
      if(i2.eq.nx1.and.j2.eq.1)go to 600
      if(i2.eq.1.or.j2.eq.1.or.i2.eq.nx1.or.j2.eq.nx2)go to 612
      go to 600
      endif
612   continue
C
C
C  Check if not already perfect
C
      ibad2=0
      call nedges(i2,j2,ibad2,nz)
C      if(ibad2.eq.0)then
C      go to 600
C      endif
C
C  detect immediate neighbours
C
      nibad=0
      if(i.eq.i2.and.iabs(j2-j).eq.1)nibad=1
      if(j.eq.j2.and.iabs(i2-i).eq.1)nibad=1
C
C  Calculate old ibad
C
C
C  Case nibad=1
C
      if(nibad.eq.1)then
      ibadt1=0
      call edges2(i,j,i2,j2,ibadt1,nz)
      else
      ibadt1=ibad+ibad2
      endif
C
C  Memorize
C
      nrpm(im)=nrp
      newpm1(im)=ipuzn(i,j)
      nim1(im)=ni(newpm1(im))
      do ij=1,4
      nbm1(im,ij)=nz(n,ij)
      enddo
      newpm2(im)=ipuzn(i2,j2)
      nim2(im)=ni(newpm2(im))
      do ij=1,4
      nbm2(im,ij)=nz(n2,ij)
      enddo
C
C  Permute
C
      ipuzn(i,j)=newpm2(im)
      ipuzn(i2,j2)=newpm1(im)
      ni(newpm2(im))=nim1(im)
      ni(newpm1(im))=nim2(im)
C
C   Forced rotation
C
C
C  Case  1,1   nx1,1 or vice versa
C
      if(i.eq.1.and.j.eq.1.and.i2.eq.nx1.and.j2.eq.1)then
      ir1=1
      ir2=3
      go to 700
      endif
      if(i.eq.nx1.and.j.eq.1.and.i2.eq.1.and.j2.eq.1)then
      ir1=3
      ir2=1
      go to 700
      endif
C
C  Case  1,1   1,nx2 or vice versa
C
      if(i.eq.1.and.j.eq.1.and.i2.eq.1.and.j2.eq.nx2)then
      ir1=3
      ir2=1
      go to 700
      endif
      if(i.eq.1.and.j.eq.nx2.and.i2.eq.1.and.j2.eq.1)then
      ir1=1
      ir2=3
      go to 700
      endif
C
C  Case  1,1   nx1,nx2 or vice versa
C
      if(i.eq.1.and.j.eq.1.and.i2.eq.nx1.and.j2.eq.nx2)then
      ir1=2
      ir2=2
      go to 700
      endif
      if(i.eq.nx1.and.j.eq.nx2.and.i2.eq.1.and.j2.eq.1)then
      ir1=2
      ir2=2
      go to 700
      endif
C
C  Case  nx1,1   nx1,nx2 or vice versa
C
      if(i.eq.nx1.and.j.eq.1.and.i2.eq.nx1.and.j2.eq.nx2)then
      ir1=1
      ir2=3
      go to 700
      endif
      if(i.eq.nx1.and.j.eq.nx2.and.i2.eq.nx1.and.j2.eq.1)then
      ir1=3
      ir2=1
      go to 700
      endif
C
C  Case  nx1,1   1,nx2 or vice versa
C
      if(i.eq.nx1.and.j.eq.1.and.i2.eq.1.and.j2.eq.nx2)then
      ir1=2
      ir2=2
      go to 700
      endif
      if(i.eq.1.and.j.eq.nx2.and.i2.eq.nx1.and.j2.eq.1)then
      ir1=2
      ir2=2
      go to 700
      endif
C
C  Case  1,nx2   nx1,nx2 or vice versa
C
      if(i.eq.1.and.j.eq.nx2.and.i2.eq.nx1.and.j2.eq.nx2)then
      ir1=3
      ir2=1
      go to 700
      endif
      if(i.eq.nx1.and.j.eq.nx2.and.i2.eq.1.and.j2.eq.nx2)then
      ir1=1
      ir2=3
      go to 700
      endif
C
C  but if y=1 or y = nx2 or x = 1 or x = nx1 for both pieces
C           then there is no rotation...
C
      if(i.eq.1.and.i2.eq.1)go to 701
      if(i.eq.nx1.and.i2.eq.nx1)go to 701
      if(j.eq.1.and.j2.eq.1)go to 701
      if(j.eq.nx2.and.j2.eq.nx2)go to 701
C
C  Case x1=1,y2=1  or x2=1 y1=1
C
      if(i.eq.1.and.j2.eq.1)then
      ir1=1
      ir2=3
      go to 700
      endif
      if(i2.eq.1.and.j.eq.1)then
      ir1=3
      ir2=1
      go to 700
      endif
C
C  Case x1=1,y2=nx2  or x2=1 y1=nx2
C
      if(i.eq.1.and.j2.eq.nx2)then
      ir1=3
      ir2=1
      go to 700
      endif
      if(i2.eq.1.and.j.eq.nx2)then
      ir1=1
      ir2=3
      go to 700
      endif
C
C  Case x1=1,x2=nx1 or x1=nx1 x2=1
C
      if(i.eq.1.and.i2.eq.nx1)then
      ir1=2
      ir2=2
      go to 700
      endif
      if(i.eq.nx1.and.i2.eq.1)then
      ir1=2
      ir2=2
      go to 700
      endif
C
C  Case x1=nx1,y2=1 or x2=nx1 y1=1
C
      if(i.eq.nx1.and.j2.eq.1)then
      ir1=3
      ir2=1
      go to 700
      endif
      if(i2.eq.nx1.and.j.eq.1)then
      ir1=1
      ir2=3
      go to 700
      endif
C
C  Case x1=x1,y2=nx2 or x2=nx1 y1=nx2
C
      if(i.eq.nx1.and.j2.eq.nx2)then
      ir1=1
      ir2=3
      go to 700
      endif
      if(j.eq.nx2.and.i2.eq.nx1)then
      ir1=3
      ir2=1
      go to 700
      endif
C
C  Case y1=1,y2=nx2 or y2=1 y1=nx2
C
      if(j.eq.1.and.j2.eq.nx2)then
      ir1=2
      ir2=2
      go to 700
      endif
      if(j2.eq.1.and.j.eq.nx2)then
      ir1=2
      ir2=2
      go to 700
      endif
C
701   continue
C
C  permute without rotation
C
      do ij=1,4
      nz(n,ij)=nbm2(im,ij)
      nz(n2,ij)=nbm1(im,ij)
      nzn(n,ij)=nbm2(im,ij)
      nzn(n2,ij)=nbm1(im,ij)
      enddo
      go to 702
C
C  rotate, then permute
C
700   call rotb(n,ir1,nz,nzn)
      do ij=1,4
      nb3(ij)=nzn(n,ij)
      enddo
      call rotb(n2,ir2,nz,nzn)
      do ij=1,4
      nb4(ij)=nzn(n2,ij)
      enddo
      do ij=1,4
      nz(n,ij)=nb4(ij)
      nz(n2,ij)=nb3(ij)
      nzn(n,ij)=nb4(ij)
      nzn(n2,ij)=nb3(ij)
      enddo
702   continue
C
C  Compute new iedges
C
C
C  Case nibad=1
C
      if(nibad.eq.1)then
      ibadt2=0
      call edges2(i,j,i2,j2,ibadt2,nz)
      else
      ibad3=0
      call nedges(i,j,ibad3,nz)
      ibad4=0
      call nedges(i2,j2,ibad4,nz)
      ibadt2=ibad3+ibad4
      endif
C
      nsum=nsum+ibadt1-ibadt2
      if(nsum.eq.ntotedge)go to 4996
C
C
C
      endif
C
C
6500  continue
C
C   Now, if all these moves have produced any improvement
C        keep them or rechange
C
      ndiff=nsum-nsum0
      nallow=0
      if(randi(iseed).le.damp.and.ndiff.ge.-ntol)nallow=1
      if(ndiff.ge.0)nallow=1
C
C  Go back if moves finally not kept 
C
      if(nallow.ne.1)then
C
C      do im=1,icalc
C
C      nrp=nrpm(im)
C      n=n1mem(im)
C      i=nx(n)
C      j=ny(n)
C
C      if(nrp.eq.1)then
C
C      n2=n2mem(im)
C      i2=nx(n2)
C      j2=ny(n2)
C      ipuzn(i,j)=newpm1(im)
C      ni(newpm1(im))=nim1(im)
C      ipuzn(i2,j2)=newpm2(im)
C      ni(newpm2(im))=nim2(im)
C      do ij=1,4
C      nz(n,ij)=nbm1(im,ij)
C      nzn(n,ij)=nz(n,ij)
C      nz(n2,ij)=nbm2(im,ij)
C      nzn(n2,ij)=nz(n2,ij)
C      enddo
C
C      else
C
C      do ij=1,4
C      nz(n,ij)=nbm1(im,ij)
C      enddo
C
C      endif
C
C      enddo
C
C
C
      do i=1,nxmax
      ni(i)=niold(i)
      enddo
      do i=1,npz
      do j=1,4
      nz(i,j)=nzold(i,j)
      nzn(i,j)=nz(i,j)
      enddo
      enddo
      do i=1,nx1
      do j=1,nx2
      ipuzn(i,j)=ipuzold(i,j)
      enddo
      enddo
C
C
C
      nsum=nsum0
      go to 5499
      endif
C
C
C
C
C
C
4996  if(nsum.gt.nsumax2)then
      do i=1,nxmax
      nis(i)=ni(i)
      enddo
      do i=1,npz
      nxs(i)=nx(i)
      nys(i)=ny(i)
      do j=1,4
      nzs(i,j)=nz(i,j)
      enddo
      enddo
      npzs=npz
      do i=1,nx1
      do j=1,nx2
      ipuzns(i,j)=ipuzn(i,j)
      enddo
      enddo
      iedges=0
      ibad=0
      call chekedge(iedges,ibad,ipuzns,nis,nzs)
      nsum=iedges
      nsumax2=nsum
C      ipr=0
      if(nsumax2.gt.nsumax3)then
C           ipr=1
           nsumax3=nsumax2
      endif
C
C  Verbosity
C
      if(iverb.ge.2)then
C
      write(*,120)nsum,npz,iii,nmove
      write(10,120)nsum,npz,iii,nmove
      write(10,*)
      write(10,*)
      write(10,*)' Total number of placed pieces :',npzs
      write(10,*)
      write(10,*)' Table with all pieces :'
      write(10,*)
      write(10,*)'        1   2   3   4   5   6   7   8   9  10  11  12 
     1 13  14  15  16'
      write(10,*)
      do i=1,nx2
      write(10,288)i,(ipuzns(j,i),j=1,nx1)
      enddo
C
C  Final check on edges satisfied...
C
      iedges=0
      ibad=0
      call chekedge(iedges,ibad,ipuzns,nis,nzs)
      write(10,*)
      write(10,*)'  Shared edges :',iedges
      write(10,*)'  Bad edges    :',ibad
      write(10,*)
C
C
      endif
C
C  end verbosity
C
C

      if(ibad.eq.0)go to 4998
      endif
C
C
C
C
      go to 5499
C
C
C
C
4998  continue
C
C  
4900  continue
C
      ipr=1
      if(ipr.eq.1)then
C
      write(*,121)nsumax2,iii
      write(10,121)nsumax2,iii
      write(*,128)nsumax3,ntotedge
      write(10,*)nsumax3,ntotedge
128   format(2x,'Max edges attained = ',i4,'/',i4)
C
C
C   Prepare reduced sorted output 
C
      write(10,*)
      write(10,*)
      WRITE(10,*)
      WRITE(10,*)'====================================================
     1==========================='
      WRITE(10,*)'       FINAL LIST OF POSITIONS :'
      WRITE(10,*)'====================================================
     1==========================='
      WRITE(10,*)
      WRITE(10,*)
C
C   correspondence with n0
C
      do i=1,nx1
      do j=1,nx2
      do k=1,nxmax
      if(ipuzns(i,j).eq.k)ipuzns2(i,j)=n0(k)
      enddo
      enddo
      enddo
C
C
C      write(10,*)
C      write(10,*)' Total number of pieces placed'
C      write(10,35)npzs
C      write(10,*)
C      do i=1,npzs
C      write(10,35)nns(i),nxs(i),nys(i),nnrs(i)
C      enddo
      write(10,*)
      write(10,*)
      write(10,*)' Total number of placed pieces :',npzs
      write(10,*)
      write(10,*)' Table with all pieces :'
      write(10,*)
      write(10,*)'        1   2   3   4   5   6   7   8   9  10  11  12 
     1 13  14  15  16'
      write(10,*)
      do i=1,nx2
      write(10,288)i,(ipuzns2(j,i),j=1,nx1)
      enddo
C
      endif
C
C  Final check on edges satisfied...
C
      iedges=0
      ibad=0
      call chekedge(iedges,ibad,ipuzns,nis,nzs)
      if(ipr.eq.1)then
      write(10,*)
      write(10,*)'  Shared edges :',iedges
      write(10,*)'  Bad edges    :',ibad
      write(10,*)
      endif
C
C
      if(ibad.eq.0)then
          write(10,*)
          write(10,*)
          write(10,*)
          write(10,*)'    CONGRATULATION !'
          write(*,*)
          write(*,*)
          write(*,*)
          write(*,*)'    CONGRATULATION !'
          write(*,*)
          write(*,*)'type 1 to continue'
          read(*,*)nnn
          go to 5012
      endif
C
C
      if(ipr.eq.1)then
C
C  Remove the bad pieces......
C
      iedges=0
      ibad=0
      call remedge(iedges,ibad,nis,ipuzns,nzs)
C
C     count the remaining pieces
C
      npzns=0
      do i=1,nx1
      do j=1,nx2
      if(ipuzns(i,j).ne.0)npzns=npzns+1
      enddo
      enddo
C
C   correspondence with n0
C
      do i=1,nx1
      do j=1,nx2
      do k=1,nxmax
      if(ipuzns(i,j).eq.k)ipuzns2(i,j)=n0(k)
      if(ipuzns(i,j).eq.0)ipuzns2(i,j)=0
      enddo
      enddo
      enddo
      write(10,*)
      write(10,*)'  Now, bad pieces are removed'
      write(10,*)
C
      write(10,*)
      write(10,*)' Total number of well placed pieces :',npzns
      write(10,*)
      write(10,*)' Table with only the well placed pieces :'
      write(10,*)
      write(10,*)'        1   2   3   4   5   6   7   8   9  10  11  12 
     1 13  14  15  16'
      write(10,*)
      do i=1,nx2
      write(10,288)i,(ipuzns2(j,i),j=1,nx1)
      enddo
      write(10,*)
      write(10,*)
      write(10,*)'====================================================='
      write(10,*)
      write(10,*)'                      Next attempt'
      write(10,*)
      write(10,*)
      write(10,*)
      write(10,*)
C
      endif
C
C  Back into the big loop
C
C
C
C
      go to 5001
C
C
5012  continue
C
C
      CALL DATN(DATENOW,TIMENOW)
      CALL CPU_TIME(time_end)
      totaltime=time_end-time_begin
      write(10,*)' Total CPU time elapsed in seconds : ',totaltime
      write(10,*)
      STOP
      END
C
*-----------------------------------------------------------------------
      subroutine init(iseed)
C
C PORLIB is compiler spcecific part, introduced for 
C using the intrinsic function SECNDS(X) which returns the 
C  (time in seconds since midnight - X) 
C
      USE PORTLIB
      X=0.
      ISEED=INT(GSECNDS(X))*2+1
      RETURN
      END
*
*----------------------------------------------------------------------- 
      function gsecnds(sek)
! machine dependent SECNDS
! replace this line by your specific call
C
C PORLIB is compiler spcecific part, introduced for 
C using the intrinsic function SECNDS(X) which returns the 
C  (time in seconds since midnight - X) 
C
      USE PORTLIB
      gsecnds=SECNDS(sek)
      return
      end
*-----------------------------------------------------------------------
*
*     Subroutine open_read1 opens a file for reading, filling in the
*     supplied extension if none is supplied with the file name.
*     Allows use of system specific facilities of open statement.
*
*
*     file formatted
*
      subroutine open_read1(unit,file)
      integer unit
      character*(*) file
      open (unit,file=file,status='old')
      return
      end
*
*     Subroutine open_write1 opens a file for writing, filling in the
*     supplied extension if none is supplied with the file name.
*     Allows use of system specific facilities of open statement.
*
*     file formatted
*
      subroutine open_write1(unit,file)
      integer unit
      character*(*) file
      open (unit,file=file,status='new')
      return
      end
*
      subroutine filedel(unit,file)
      integer unit
      character*(*) file
      open (unit,file=file,status='old')
      close(unit,status='delete')
      return
      end
*
*-----------------------------------------------------------------------
      SUBROUTINE DATN(DATENOW,TIMENOW)
C
C Obviously, this subroutine is compiler specific...
C
C In case of problem, remove that subroutine and all 
C the CALL DATN inside the program.
C
C Date will be printed as follows :
C
C     10-Apr-2000   Hour:  0 Min: 29 Sec: 20 
C
C     dd-mmm-yyyy          hh     mm      ss 
C
C     DT_VALUES(3),MONTHS(DT_VALUES(2)),DT_VALUES(1), 
C     DT_VALUES(5),DT_VALUES(6),DT_VALUES(7) 
C
C
      CHARACTER*7 DATENOW
      CHARACTER*8 TIMENOW
      CHARACTER*8 DA
      CHARACTER*10 TIME
      CHARACTER*5 ZONE
	CHARACTER*2 YEAR
      INTEGER*4 DT_VALUES(8)    ! Return values from DATE_AND_TIME
      CHARACTER*3 MONTHS(12)    ! Month names
      DATA MONTHS /'Jan','Feb','Mar','Apr','May','Jun',
     1             'Jul','Aug','Sep','Oct','Nov','Dec'/

C
C Get current date values
C
       CALL DATE_AND_TIME (DA,TIME,ZONE,DT_VALUES) 
C
C Format date
C
      WRITE(10,*)
      WRITE(10,10) DT_VALUES(3),
     1 MONTHS(DT_VALUES(2)),DT_VALUES(1),DT_VALUES(5),
     2 DT_VALUES(6),DT_VALUES(7)
      WRITE(10,*)
10    FORMAT(1X,I2,'-',A3,'-',I4,5X,I2,' hour ',I2,' min ',I2,
     -' Sec ')
	IF(DT_VALUES(1).EQ.2006)YEAR='06'
	IF(DT_VALUES(1).EQ.2007)YEAR='07'
	IF(DT_VALUES(1).EQ.2008)YEAR='08'
	IF(DT_VALUES(1).EQ.2009)YEAR='09'
	IF(DT_VALUES(1).EQ.2010)YEAR='10'
	IF(DT_VALUES(1).EQ.2011)YEAR='11'
	IF(DT_VALUES(1).EQ.2012)YEAR='12'
	IF(DT_VALUES(1).EQ.2013)YEAR='13'
	IF(DT_VALUES(1).EQ.2014)YEAR='14'
	IF(DT_VALUES(1).EQ.2015)YEAR='15'
	IF(DT_VALUES(1).EQ.2016)YEAR='16'
	IF(DT_VALUES(1).EQ.2017)YEAR='17'
	IF(DT_VALUES(1).EQ.2018)YEAR='18'
	IF(DT_VALUES(1).EQ.2019)YEAR='19'
	WRITE(DATENOW,'(I2,A3,A2)')
     1DT_VALUES(3),MONTHS(DT_VALUES(2)),YEAR
	WRITE(TIMENOW,'(I2,A,I2,A,I2)')
     1DT_VALUES(5),':',DT_VALUES(6),':',DT_VALUES(7)
C
C  End of compiler specific subroutine
C
      RETURN
      END
*
*
*
*
      real function randi(ix)
      implicit integer*4 (a-z)
      real*8 x,s
*
*     A random number generator using the recursion IX=IX*A MOD P
*     where A=7**5 and P=2**31-1. The value returned is in the 
*     range 0.<= ran <1.
*
*     In this form fairly portable as does not require knowledge
*     of data storage, but does not adhere to the standard in two respects:
*     1) Assumes an integer word length of at least 32 bits 
*     2) Assumes that a positive integer less than 2**16 may be
*        floated without loss of digits.
*
*     This code is based on code published by Linus Schrage in
*     T.O.M.S. vol.5 no.2 June 1979 (pp 132-138)
*
*     The method employed is a multiplicative congruential one using a 
*     multiplier of 7**5 and taking the modulo to 2**31-1, i.e. the
*     generator number, x, is updated on each call to the value
*     x*7**5  modulo (2**31-1). The result returned is calculated as a 
*     real number having the value x/(2**31-1)  
*
      parameter (a=16807)
      parameter (b15=32768)
      parameter (b16=65536)
      parameter (p=2147483647)
      parameter (s=1d0/p)
*     a=7**5, b15=2**15, b16=2**16, p= 2**31-1
*
*     Get the 15 high order bits and 16 low order bits of ix
*
      xhi=ix/b16
      xlo=ix-xhi*b16
*
*     Multiply low order part
*
      xalo=xlo*a
*
*     Get high order part of product to carry
*
      leftlo=xalo/b16
*
*     And so obtain high order part of product
*
      xahi=xhi*a+leftlo
*
*     Obtain 32nd bit (overflow) of full product
*
      k=xahi/b15
*
*     Put all the bits of the product together and subtract p
*     (Must be in this form to prevent overflow. The ()'s are essential)
*
      ix=(((xalo-leftlo*b16 )-p) +(xahi-k*b15)*b16) +k
*
*     If <0 add p back again
*
      if (ix.lt.0) ix=ix+p
*
*     Finally multiply by 1/(2**31-1) to obtain number in range 0-1
*
      xhi=ix/b16
      x=dble(xhi)*65536.0d0+dble(ix-xhi*b16)
      x=x*s
      randi=sngl(x)
      return
      end
C
C
C ------------------------------------------------------------
C
C
C  Applying rotation
C
      subroutine rot(ih,npz,nrot)
      parameter (maxp=257)
      integer np(maxp,4),nz(maxp,4)
      common/rota/np,nz
C
C  no rotation
C
      if(nrot.eq.0)then
      nz(npz,1)=np(ih,1)
      nz(npz,2)=np(ih,2)
      nz(npz,3)=np(ih,3)
      nz(npz,4)=np(ih,4)
      endif
C
C  rotation 90
C
      if(nrot.eq.1)then
      nz(npz,1)=np(ih,4)
      nz(npz,2)=np(ih,1)
      nz(npz,3)=np(ih,2)
      nz(npz,4)=np(ih,3)
      endif
C
C  rotation 180
C
      if(nrot.eq.2)then
      nz(npz,1)=np(ih,3)
      nz(npz,2)=np(ih,4)
      nz(npz,3)=np(ih,1)
      nz(npz,4)=np(ih,2)
      endif
C
C  rotation 270
C
      if(nrot.eq.3)then
      nz(npz,1)=np(ih,2)
      nz(npz,2)=np(ih,3)
      nz(npz,3)=np(ih,4)
      nz(npz,4)=np(ih,1)
      endif
      return
      end
C
C   Correspondences of edges
C
      subroutine corned(ned,nned)
      integer ned(4),nned(4)
C
C    According to ned, the nned place of the fig for
C       that new piece will be nned
C              nned = 3   if ned = 1
C              nned = 4   if ned = 2
C              nned = 1   if ned = 3
C              nned = 2   if ned = 4
C
      do i=1,4
      if(ned(i).lt.3)then
      nned(i)=ned(i)+2
      else
      nned(i)=ned(i)-2
      endif
      enddo
      return
      end
C
C
C  Checking if piece nnxx,nnyy do not generate places
C          that will not have any complete neighbours
C
C
      subroutine backtr(npr,nf)
C
C      call backtr(npz,j)
C
C     npr = npz of the new piece
C     nf  = future places to check, 1 to 4 ... to 3 max in fact)
C     nxfr(nf) = nnxx of the checked piece nf
C     nyfr(nf) = nnyy of the checked piece nf
C     nedfr(nf) = ned(1) of the checked piece nf
C     
C
      parameter (maxp=257,maxdif=31)
      integer np(maxp,4),nz(maxp,4)
      integer mmfig(maxdif,maxp),nnfig(maxdif)
      integer ni(maxp)
      integer ipuzn(16,16)
      integer ned(4),nned(4),nfi(4),nps(4),nforce(4)
C
      integer nxfr(4),nyfr(4),nedfr(4),ncheck(4)
C
      common/rota/np,nz
      common/back/nxfr,nyfr,nedfr,nnfig,mmfig,ncheck,ifign,nforce,nscar
      common/puz/ni,ipuzn
      common/size/nx1,nx2,nxmax,nx3,nx4,nx5,nx6
C
C
C   Not randomly that time...
C     we just want to check if complete neighbours will
C       exist for that piece nf (then sum.ne.0)
C
C
C   Position and numbers of the piece       
C
C
C   ned = edge number
C
      ned(1)=nedfr(nf)
C
C  If ncheck(nf)= 0 at the end of that stuff
C           then it is OK for piece nf
C
      ncheck(nf)=0
C
C   the figure of this piece is defined
C
      nfi(1)=nz(npr,ned(1))
C
C   nnfi = number of figures to satisfy 
C
      nnfi=1
C
C
C  Coordinates of the piece nf to check
C
      nnxx=nxfr(nf)
      nnyy=nyfr(nf)
C
C  OK, we have a new piece to place now...
C        see if it is at a corner, a border, or else ?
C        then see if there are other neighbours ?
C
C
C  Is the place (nnxx,nnyy) for the new piece a border or a corner ?
C     corners are 1,1  1,nx2  nx1,1  or nx1,nx2    :   nb=2
C     borders are 1,2 to 1,nx2                  :   nb=1
C                2,1 to nx3,1                         "
C                2,nx2 to nx3,nx2                       "
C                nx1,2 to nx1,nx4                       "
C     outside borders                          :   nb=0
C
      if(nnxx.eq.1.or.nnxx.eq.nx1.or.nnyy.eq.1.or.nnyy.eq.nx2)then
C
C  Yes, the new piece will be on the border or at a corner
C
C
C  Are there other close pieces already ??
C
C     Case with the new piece to be placed at (1,1)
C
      if(nnxx.eq.1.and.nnyy.eq.1)then
      nb=2
C  check for another neighbour
      if(ned(1).eq.1)then
        if(ipuzn(2,1).ne.0)then
        nnfi=4
        nps(2)=ni(ipuzn(2,1))
        nfi(2)=nz(nps(2),4)
        ned(2)=4
        nfi(3)=0
        nfi(4)=0
        ned(3)=3
        ned(4)=2
        go to 3000
        else
        nnfi=3
        nfi(2)=0
        nfi(3)=0
        ned(2)=3
        ned(3)=2
        go to 3000
        endif
      endif
C
      if(ned(1).eq.4)then
        if(ipuzn(1,2).ne.0)then
        nnfi=4
        nps(2)=ni(ipuzn(1,2))
        nfi(2)=nz(nps(2),1)
        ned(2)=1
        nfi(3)=0
        nfi(4)=0
        ned(3)=3
        ned(4)=2
        go to 3000
        else
        nnfi=3
        nfi(2)=0
        nfi(3)=0
        ned(2)=3
        ned(3)=2
        go to 3000
        endif
      endif
C
      endif
C
C  End of case (1,1)
C
C
C     Case with the new piece to be placed at (nx1,1)
C
      if(nnxx.eq.nx1.and.nnyy.eq.1)then
      nb=2
      if(ned(1).eq.1)then
        if(ipuzn(nx3,1).ne.0)then
        nnfi=4
        nps(2)=ni(ipuzn(nx3,1))
        nfi(2)=nz(nps(2),2)
        ned(2)=2
        nfi(3)=0
        nfi(4)=0
        ned(3)=3
        ned(4)=4
        go to 3000
        else
        nnfi=3
        nfi(2)=0
        nfi(3)=0
        ned(2)=3
        ned(3)=4
        go to 3000
        endif
      endif
C
      if(ned(1).eq.2)then
        if(ipuzn(nx1,2).ne.0)then
        nnfi=4
        nps(2)=ni(ipuzn(nx1,2))
        nfi(2)=nz(nps(2),1)
        ned(2)=1
        nfi(3)=0
        nfi(4)=0
        ned(3)=3
        ned(4)=4
        go to 3000
        else
        nnfi=3
        nfi(2)=0
        nfi(3)=0
        ned(2)=3
        ned(3)=4
        go to 3000
        endif
      endif
C
      endif
C
C  End of case (nx1,1)
C
C
C     Case with the new piece to be placed at (1,nx2)
C
      if(nnxx.eq.1.and.nnyy.eq.nx2)then
      nb=2
      if(ned(1).eq.3)then
        if(ipuzn(2,nx2).ne.0)then
        nnfi=4
        nps(2)=ni(ipuzn(2,nx2))
        nfi(2)=nz(nps(2),4)
        ned(2)=4
        nfi(3)=0
        nfi(4)=0
        ned(3)=2
        ned(4)=1
        go to 3000
        else
        nnfi=3
        nfi(2)=0
        nfi(3)=0
        ned(2)=2
        ned(3)=1
        go to 3000
        endif
      endif
C
      if(ned(1).eq.4)then
        if(ipuzn(1,nx4).ne.0)then
        nnfi=4
        nps(2)=ni(ipuzn(1,nx4))
        nfi(2)=nz(nps(2),3)
        ned(2)=3
        nfi(3)=0
        nfi(4)=0
        ned(3)=2
        ned(4)=1
        go to 3000
        else
        nnfi=3
        nfi(2)=0
        nfi(3)=0
        ned(2)=2
        ned(3)=1
        go to 3000
        endif
      endif
C
      endif
C
C  End of case (1,nx2)
C
C
C     Case with the new piece to be placed at (nx1,nx2)
C
      if(nnxx.eq.nx1.and.nnyy.eq.nx2)then
      nb=2
      if(ned(1).eq.2)then
        if(ipuzn(nx1,nx4).ne.0)then
        nnfi=4
        nps(2)=ni(ipuzn(nx1,nx4))
        nfi(2)=nz(nps(2),3)
        ned(2)=3
        nfi(3)=0
        nfi(4)=0
        ned(3)=4
        ned(4)=1
        go to 3000
        else
        nnfi=3
        nfi(2)=0
        nfi(3)=0
        ned(2)=4
        ned(3)=1
        go to 3000
        endif
      endif
C
      if(ned(1).eq.3)then
        if(ipuzn(nx3,nx2).ne.0)then
        nnfi=4
        nps(2)=ni(ipuzn(nx3,nx2))
        nfi(2)=nz(nps(2),2)
        ned(2)=2
        nfi(3)=0
        nfi(4)=0
        ned(3)=4
        ned(4)=1
        go to 3000
        else
        nnfi=3
        nfi(2)=0
        nfi(3)=0
        ned(2)=4
        ned(3)=1
        go to 3000
        endif
      endif
C
      endif
C
C  End of case (nx1,nx2)
C
C
C  Now, see the borders...
C
C
C     Case with the new piece to be placed at border (x=1,y)
C
      if(nnxx.eq.1)then
      nb=1
      if(ned(1).eq.1)then
        if(ipuzn(1,nnyy-1).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(1,nnyy-1))
        nfi(nnfi)=nz(nps(nnfi),3)
        ned(nnfi)=3
        endif
        if(ipuzn(2,nnyy).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(2,nnyy))
        nfi(nnfi)=nz(nps(nnfi),4)
        ned(nnfi)=4
        endif
        nnfi=nnfi+1
        nfi(nnfi)=0
        ned(nnfi)=2
        go to 3000
      endif
C
      if(ned(1).eq.3)then
        if(ipuzn(1,nnyy+1).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(1,nnyy+1))
        nfi(nnfi)=nz(nps(nnfi),1)
        ned(nnfi)=1
        endif
        if(ipuzn(2,nnyy).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(2,nnyy))
        nfi(nnfi)=nz(nps(nnfi),4)
        ned(nnfi)=4
        endif
        nnfi=nnfi+1
        nfi(nnfi)=0
        ned(nnfi)=2
        go to 3000
      endif
C
      if(ned(1).eq.4)then
        if(ipuzn(1,nnyy-1).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(1,nnyy-1))
        nfi(nnfi)=nz(nps(nnfi),3)
        ned(nnfi)=3
        endif
        if(ipuzn(1,nnyy+1).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(1,nnyy+1))
        nfi(nnfi)=nz(nps(nnfi),1)
        ned(nnfi)=1
        endif
        nnfi=nnfi+1
        nfi(nnfi)=0
        ned(nnfi)=2
        go to 3000
      endif
C
      endif
C
C  End of case (1,y)
C
C
C     Case with the new piece to be placed at border (x,y=1)
C
      if(nnyy.eq.1)then
      nb=1
      if(ned(1).eq.1)then
        if(ipuzn(nnxx-1,1).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx-1,1))
        nfi(nnfi)=nz(nps(nnfi),2)
        ned(nnfi)=2
        endif
        if(ipuzn(nnxx+1,1).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx+1,1))
        nfi(nnfi)=nz(nps(nnfi),4)
        ned(nnfi)=4
        endif
        nnfi=nnfi+1
        nfi(nnfi)=0
        ned(nnfi)=3
        go to 3000
      endif
C
      if(ned(1).eq.2)then
        if(ipuzn(nnxx+1,1).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx+1,1))
        nfi(nnfi)=nz(nps(nnfi),4)
        ned(nnfi)=4
        endif
        if(ipuzn(nnxx,2).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx,2))
        nfi(nnfi)=nz(nps(nnfi),1)
        ned(nnfi)=1
        endif
        nnfi=nnfi+1
        nfi(nnfi)=0
        ned(nnfi)=3
        go to 3000
      endif
C
      if(ned(1).eq.4)then
        if(ipuzn(nnxx-1,1).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx-1,1))
        nfi(nnfi)=nz(nps(nnfi),2)
        ned(nnfi)=2
        endif
        if(ipuzn(nnxx,2).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx,2))
        nfi(nnfi)=nz(nps(nnfi),1)
        ned(nnfi)=1
        endif
        nnfi=nnfi+1
        nfi(nnfi)=0
        ned(nnfi)=3
        go to 3000
      endif
C
      endif
C
C  End of case (x,1)
C
C
C     Case with the new piece to be placed at border (x=nx1,y)
C
      if(nnxx.eq.nx1)then
      nb=1
      if(ned(1).eq.1)then
        if(ipuzn(nx1,nnyy-1).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nx1,nnyy-1))
        nfi(nnfi)=nz(nps(nnfi),3)
        ned(nnfi)=3
        endif
        if(ipuzn(nx3,nnyy).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nx3,nnyy))
        nfi(nnfi)=nz(nps(nnfi),2)
        ned(nnfi)=2
        endif
        nnfi=nnfi+1
        nfi(nnfi)=0
        ned(nnfi)=4
       go to 3000
      endif
C
      if(ned(1).eq.2)then
        if(ipuzn(nx1,nnyy-1).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nx1,nnyy-1))
        nfi(nnfi)=nz(nps(nnfi),3)
        ned(nnfi)=3
        endif
        if(ipuzn(nx1,nnyy+1).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nx1,nnyy+1))
        nfi(nnfi)=nz(nps(nnfi),1)
        ned(nnfi)=1
        endif
        nnfi=nnfi+1
        nfi(nnfi)=0
        ned(nnfi)=4
        go to 3000
      endif
C
      if(ned(1).eq.3)then
        if(ipuzn(nx1,nnyy+1).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nx1,nnyy+1))
        nfi(nnfi)=nz(nps(nnfi),1)
        ned(nnfi)=1
        endif
        if(ipuzn(nx3,nnyy).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nx3,nnyy))
        nfi(nnfi)=nz(nps(nnfi),2)
        ned(nnfi)=2
        endif
        nnfi=nnfi+1
        nfi(nnfi)=0
        ned(nnfi)=4
        go to 3000
      endif
C
      endif
C
C  End of case (nx1,y)
C
C
C     Case with the new piece to be placed at border (x,nx2)
C
      if(nnyy.eq.nx2)then
      nb=1
      if(ned(1).eq.2)then
        if(ipuzn(nnxx+1,nx2).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx+1,nx2))
        nfi(nnfi)=nz(nps(nnfi),4)
        ned(nnfi)=4
        endif
        if(ipuzn(nnxx,nx4).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx,nx4))
        nfi(nnfi)=nz(nps(nnfi),3)
        ned(nnfi)=3
        endif
        nnfi=nnfi+1
        nfi(nnfi)=0
        ned(nnfi)=1
        go to 3000
      endif
C
      if(ned(1).eq.3)then
        if(ipuzn(nnxx-1,nx2).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx-1,nx2))
        nfi(nnfi)=nz(nps(nnfi),2)
        ned(nnfi)=2
        endif
        if(ipuzn(nnxx+1,nx2).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx+1,nx2))
        nfi(nnfi)=nz(nps(nnfi),4)
        ned(nnfi)=4
        endif
        nnfi=nnfi+1
        nfi(nnfi)=0
        ned(nnfi)=1
        go to 3000
      endif
C
      if(ned(1).eq.4)then
        if(ipuzn(nnxx-1,nx2).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx-1,nx2))
        nfi(nnfi)=nz(nps(nnfi),2)
        ned(nnfi)=2
        endif
        if(ipuzn(nnxx,nx4).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx,nx4))
        nfi(nnfi)=nz(nps(nnfi),3)
        ned(nnfi)=3
        endif
        nnfi=nnfi+1
        nfi(nnfi)=0
        ned(nnfi)=1
        go to 3000
      endif
C
      endif
C
C  End of case (x,nx2)
C
      else
C
C  And now, the general case, not corner nor border
C
      nb=0
      if(ned(1).eq.1)then
        if(ipuzn(nnxx-1,nnyy).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx-1,nnyy))
        nfi(nnfi)=nz(nps(nnfi),2)
        ned(nnfi)=2
        endif
        if(ipuzn(nnxx,nnyy-1).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx,nnyy-1))
        nfi(nnfi)=nz(nps(nnfi),3)
        ned(nnfi)=3
        endif
        if(ipuzn(nnxx+1,nnyy).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx+1,nnyy))
        nfi(nnfi)=nz(nps(nnfi),4)
        ned(nnfi)=4
        endif
        go to 3000
      endif
C
      if(ned(1).eq.2)then
        if(ipuzn(nnxx,nnyy-1).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx,nnyy-1))
        nfi(nnfi)=nz(nps(nnfi),3)
        ned(nnfi)=3
        endif
        if(ipuzn(nnxx+1,nnyy).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx+1,nnyy))
        nfi(nnfi)=nz(nps(nnfi),4)
        ned(nnfi)=4
        endif
        if(ipuzn(nnxx,nnyy+1).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx,nnyy+1))
        nfi(nnfi)=nz(nps(nnfi),1)
        ned(nnfi)=1
        endif
        go to 3000
      endif
C
      if(ned(1).eq.3)then
        if(ipuzn(nnxx+1,nnyy).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx+1,nnyy))
        nfi(nnfi)=nz(nps(nnfi),4)
        ned(nnfi)=4
        endif
        if(ipuzn(nnxx,nnyy+1).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx,nnyy+1))
        nfi(nnfi)=nz(nps(nnfi),1)
        ned(nnfi)=1
        endif
        if(ipuzn(nnxx-1,nnyy).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx-1,nnyy))
        nfi(nnfi)=nz(nps(nnfi),2)
        ned(nnfi)=2
        endif
        go to 3000
      endif
C
      if(ned(1).eq.4)then
        if(ipuzn(nnxx,nnyy+1).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx,nnyy+1))
        nfi(nnfi)=nz(nps(nnfi),1)
        ned(nnfi)=1
        endif
        if(ipuzn(nnxx-1,nnyy).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx-1,nnyy))
        nfi(nnfi)=nz(nps(nnfi),2)
        ned(nnfi)=2
        endif
        if(ipuzn(nnxx,nnyy-1).ne.0)then
        nnfi=nnfi+1
        nps(nnfi)=ni(ipuzn(nnxx,nnyy-1))
        nfi(nnfi)=nz(nps(nnfi),3)
        ned(nnfi)=3
        endif
        go to 3000
      endif
C
C  End of checking for neighbours of the possible new piece
C 
      endif
C
C
C
3000  continue
C
C  Now, search for the possibly corresponding piece among 
C       the remaining ones
C
C
      go to (3001,3002,3003,3004)nnfi
C
C     Case with only one neigbour nnfi = 1
C
3001  continue
C
C     OK, only one figure to satisfy, then it is always = nfi(1) 
C         so, is there any remaining piece with that figure ?
C         care also to the nb value...
C              nb=2 then this is a piece to place at a corner
C              nb=1 then this is a piece to place at a border
C              nb=0 then this is a piece to place elsewhere
C
      nforce(nf)=0
      kfig=nfi(1)+1
C
C   Correspondences of edges
C
      call corned(ned,nned)
C
C
C
C  Special cases
C      a)   border    
C
      if(nb.eq.1)kfig=1
C
C      b)  corner
C
      if(nb.eq.2)kfig=ifign
C
C
C
      num=nnfig(kfig)
      if(num.eq.0)then
         ncheck(nf)=1
      return
      endif
      if(num.le.nscar)then
        nforce(nf)=1
      endif
      return
C
C     Case with two neigbours       nnfi = 2
C              adjacent or
C              opposite
3002  continue
C
C     OK, two figures to satisfy,  
C       so, is there any remaining piece(s) with these figures ?
C       care also to the nb value...
C              nb=2 then this is a piece to place at a corner
C              nb=1 then this is a piece to place at a border
C              nb=0 then this is a piece to place elsewhere
C
      nforce(nf)=0
      kfig=nfi(1)+1
C
C   Correspondences of edges
C
      call corned(ned,nned)
C
C
C
C  Special cases
C      a)   border    
C
      if(nb.eq.1)kfig=1
C
C      b)  corner
C
      if(nb.eq.2)kfig=ifign
C
C
C
      num=nnfig(kfig)
      if(num.eq.0)then
        ncheck(nf)=1
      return
      endif
C
C    If yes, then check more preciseley on the 2 pieces...
C
      if(nb.eq.0)then
C
C                  with  two figures...
C
      num=0
      do i=1,nnfig(nfi(1)+1)
      m=mmfig(nfi(1)+1,i)
C      write(*,*)m,(np(m,jj),jj=1,4)
      do j=1,4
      i2=nned(2)+j
      i1=nned(1)+j
      if(i1.gt.4)i1=i1-4
      if(i2.gt.4)i2=i2-4
      if(np(m,i2).eq.nfi(2).and.np(m,i1).eq.nfi(1))then
      num=num+1
      go to 2001
      endif
      enddo
2001  continue
      enddo
      if(num.eq.0)then
        ncheck(nf)=1
      return
      endif
C
      if(num.le.nscar)then
        nforce(nf)=1
      endif
C
      return
      endif
C
C
C
      if(nb.eq.1)then
C
C        check with such two figures...
C
      num=0
      do i=1,nnfig(1)
      m=mmfig(1,i)
C      write(*,*)m,(np(m,jj),jj=1,4)
      do j=1,4
      i2=nned(2)+j
      i1=nned(1)+j
      if(i1.gt.4)i1=i1-4
      if(i2.gt.4)i2=i2-4
      if(np(m,i2).eq.nfi(2).and.np(m,i1).eq.nfi(1))then
      num=num+1
      go to 2002
      endif
      enddo
2002  continue
      enddo
      if(num.eq.0)then
      ncheck(nf)=1
      return
      endif
      if(num.le.nscar)then
        nforce(nf)=1
      endif
C
      return
      endif
      return
C
C     Case with three neigbours    nnfi = 3
C
3003  continue
C
C     OK, three figures to satisfy,  
C       so, is there any remaining piece(s) with these figures ?
C       care also to the nb value...
C              nb=2 then this is a piece to place at a corner
C              nb=1 then this is a piece to place at a border
C              nb=0 then this is a piece to place elsewhere
C
      nforce(nf)=0
      kfig=nfi(1)+1
C
C   Correspondences of edges
C
      call corned(ned,nned)
C
C
C  Special cases
C      a)   border    
C
      if(nb.eq.1)kfig=1
C
C      b)  corner
C
      if(nb.eq.2)kfig=ifign
C
C
      num=nnfig(kfig)
      if(num.eq.0)then
        ncheck(nf)=1
      return
      endif
C
C    If yes, then verify neighbours...
C
C
C
      if(nb.eq.0)then
C
C                  with three figures...
C
      num=0
      do i=1,nnfig(nfi(1)+1)
C      write(*,*)m,(np(m,jj),jj=1,4)
      m=mmfig(nfi(1)+1,i)
      do j=1,4
      i3=nned(3)+j
      i2=nned(2)+j
      i1=nned(1)+j
      j1=nfi(1)
      j2=nfi(2)
      j3=nfi(3)
      if(i1.gt.4)i1=i1-4
      if(i2.gt.4)i2=i2-4
      if(i3.gt.4)i3=i3-4
      if(np(m,i1).eq.j1.and.np(m,i2).eq.j2.and.np(m,i3).eq.j3)then
      num=num+1
      go to 2004
      endif
      enddo
2004  continue
      enddo
      if(num.eq.0)then
         ncheck(nf)=1
         return
      endif
      if(num.le.nscar)then
        nforce(nf)=1
      endif
C
      return
      endif
C
C
C
      if(nb.eq.1)then
C
C                  with three figures...
C
      num=0
      do i=1,nnfig(1)
      m=mmfig(1,i)
C      write(*,*)m,(np(m,jj),jj=1,4)
      do j=1,4
      i3=nned(3)+j
      i2=nned(2)+j
      i1=nned(1)+j
      j1=nfi(1)
      j2=nfi(2)
      j3=nfi(3)
      if(i1.gt.4)i1=i1-4
      if(i2.gt.4)i2=i2-4
      if(i3.gt.4)i3=i3-4
      if(np(m,i1).eq.j1.and.np(m,i2).eq.j2.and.np(m,i3).eq.j3)then
      num=num+1
      go to 2005
      endif
      enddo
2005  continue
      enddo
      if(num.eq.0)then
        ncheck(nf)=1
        return
      endif
      if(num.le.nscar)then
        nforce(nf)=1
      endif
C
      return
      endif
C
C
C
      if(nb.eq.2)then
C
C                  with three figures...
C
      num=0
      do i=1,nnfig(ifign)
      m=mmfig(ifign,i)
C      write(*,*)m,(np(m,jj),jj=1,4)
      do j=1,4
      i3=nned(3)+j
      i2=nned(2)+j
      i1=nned(1)+j
      j1=nfi(1)
      j2=nfi(2)
      j3=nfi(3)
      if(i1.gt.4)i1=i1-4
      if(i2.gt.4)i2=i2-4
      if(i3.gt.4)i3=i3-4
      if(np(m,i1).eq.j1.and.np(m,i2).eq.j2.and.np(m,i3).eq.j3)then
      num=num+1
      go to 2012
      endif
      enddo
2012  continue
      enddo
      if(num.eq.0)then
      ncheck(nf)=1
      return
      endif
      if(num.le.nscar)then
        nforce(nf)=1
      endif
C
      return
      endif
      return
C
C     Case with 4 neigbours       nnfi = 4
C
3004  continue
C
C     OK, four figures to satisfy,  
C       so, is there any remaining piece(s) with these figures ?
C       care also to the nb value...
C              nb=2 then this is a piece to place at a corner
C              nb=1 then this is a piece to place at a border
C              nb=0 then this is a piece to place elsewhere
C
      nforce(nf)=0
      kfig=nfi(1)+1
C
C   Correspondences of edges
C
      call corned(ned,nned)
C
C
C  Special cases
C      a)   border    
C
      if(nb.eq.1)kfig=1
C
C      b)  corner
C
      if(nb.eq.2)kfig=ifign
C
C
      num=nnfig(kfig)
      if(num.eq.0)then
        ncheck(nf)=1
        return
      endif
C
C    If yes, then verify neighbouring...
C
C
C
      if(nb.eq.0)then
C
C                  with such four figures...
C
C
      num=0
      do i=1,nnfig(nfi(1)+1)
      m=mmfig(nfi(1)+1,i)
      do j=1,4
      i4=nned(4)+j
      i3=nned(3)+j
      i2=nned(2)+j
      i1=nned(1)+j
      j1=nfi(1)
      j2=nfi(2)
      j3=nfi(3)
      j4=nfi(4)
      if(i1.gt.4)i1=i1-4
      if(i2.gt.4)i2=i2-4
      if(i3.gt.4)i3=i3-4
      if(i4.gt.4)i4=i4-4
      if(np(m,i1).eq.j1.and.np(m,i2).eq.j2.and.np(m,i3).eq.j3.
     1and.np(m,i4).eq.j4)then
      num=num+1
      go to 2007
      endif
      enddo
2007  continue
      enddo
      if(num.eq.0)then
        ncheck(nf)=1
        return
      endif
      if(num.le.nscar)then
        nforce(nf)=1
      endif
C
      return
      endif
C
C
C
      if(nb.eq.1)then
C
C
      num=0
      do i=1,nnfig(1)
      m=mmfig(1,i)
      do j=1,4
      i4=nned(4)+j
      i3=nned(3)+j
      i2=nned(2)+j
      i1=nned(1)+j
      j1=nfi(1)
      j2=nfi(2)
      j3=nfi(3)
      j4=nfi(4)
      if(i1.gt.4)i1=i1-4
      if(i2.gt.4)i2=i2-4
      if(i3.gt.4)i3=i3-4
      if(i4.gt.4)i4=i4-4
      if(np(m,i1).eq.j1.and.np(m,i2).eq.j2.and.np(m,i3).eq.j3.
     1and.np(m,i4).eq.j4)then
      num=num+1
      go to 2008
      endif
      enddo
2008  continue
      enddo
      if(num.eq.0)then
        ncheck(nf)=1
        return
      endif
      if(num.le.nscar)then
        nforce(nf)=1
      endif
C
      return
      endif
C
C   Piece at a corner
C
      if(nb.eq.2)then
C
C        nfi(1), nfi(2), nfi(3) and nfi(4)
C
      num=0
      do i=1,nnfig(ifign)
      m=mmfig(ifign,i)
      do j=1,4
      i4=nned(4)+j
      i3=nned(3)+j
      i2=nned(2)+j
      i1=nned(1)+j
      j1=nfi(1)
      j2=nfi(2)
      j3=nfi(3)
      j4=nfi(4)
      if(i1.gt.4)i1=i1-4
      if(i2.gt.4)i2=i2-4
      if(i3.gt.4)i3=i3-4
      if(i4.gt.4)i4=i4-4
      if(np(m,i1).eq.j1.and.np(m,i2).eq.j2.and.np(m,i3).eq.j3.
     1and.np(m,i4).eq.j4)then
      num=num+1
      go to 2009
      endif
      enddo
2009  continue
      enddo
      if(num.eq.0)then
        ncheck(nf)=1
        return
      endif
      if(num.le.nscar)then
        nforce(nf)=1
      endif
C
      endif
C
C
      return
      end
C
C  Final check on edges satisfied...
C
      subroutine chekedge(iedges,ibad,ipuzns,nis,nzs)
C
C
      parameter (maxp=257)
      integer nis(maxp),nzs(maxp,4)
      integer ipuzns(16,16)
      common/size/nx1,nx2,nxmax,nx3,nx4,nx5,nx6
C
C
C  Center
C
      do i=2,nx3
      do j=2,nx4
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i,j-1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,3)
      if(i1.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      np2=ipuzns(i+1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,4)
      if(i2.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      np2=ipuzns(i,j+1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,1)
      if(i3.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      np2=ipuzns(i-1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,2)
      if(i4.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      endif
      enddo
      enddo
C
C  Corners
C
      i=1
      j=1
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i+1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,4)
      if(i2.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      np2=ipuzns(i,j+1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,1)
      if(i3.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      endif
C
      i=nx1
      j=1
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i,j+1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,1)
      if(i3.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      np2=ipuzns(i-1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,2)
      if(i4.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      endif
C
      i=1
      j=nx2
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i,j-1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,3)
      if(i1.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      np2=ipuzns(i+1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,4)
      if(i2.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      endif
C
      i=nx1
      j=nx2
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i,j-1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,3)
      if(i1.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      np2=ipuzns(i-1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,2)
      if(i4.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      endif
C
C  Borders
C
      i=1
      do j=2,nx4
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i,j-1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,3)
      if(i1.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      np2=ipuzns(i+1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,4)
      if(i2.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      np2=ipuzns(i,j+1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,1)
      if(i3.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      endif
      enddo
C
      j=1
      do i=2,nx3
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i+1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,4)
      if(i2.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      np2=ipuzns(i,j+1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,1)
      if(i3.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      np2=ipuzns(i-1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,2)
      if(i4.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      endif
      enddo
C
      i=nx1
      do j=2,nx4
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i,j-1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,3)
      if(i1.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      np2=ipuzns(i,j+1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,1)
      if(i3.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      np2=ipuzns(i-1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,2)
      if(i4.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      endif
      enddo
C
      j=nx2
      do i=2,nx3
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i,j-1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,3)
      if(i1.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      np2=ipuzns(i+1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,4)
      if(i2.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      np2=ipuzns(i-1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,2)
      if(i4.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      endif
      enddo
      iedges=iedges/2
      ibad=ibad/2
      return
      end
C
C
C
C
C  Check on edges satisfied for the last placed piece...
C
      subroutine edges(i,j,iedges,ibad,ipuzns,nis,nzs)
C
C
      parameter (maxp=257)
      integer nis(maxp),nzs(maxp,4)
      integer ipuzns(16,16)
      common/size/nx1,nx2,nxmax,nx3,nx4,nx5,nx6
C
C
C  Corners
C
      if(i.eq.1.and.j.eq.1)then
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i+1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,4)
      if(i2.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      np2=ipuzns(i,j+1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,1)
      if(i3.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      endif
      return
      endif
C
      if(i.eq.nx1.and.j.eq.1)then
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i,j+1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,1)
      if(i3.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      np2=ipuzns(i-1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,2)
      if(i4.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      endif
      return
      endif
C
      if(i.eq.1.and.j.eq.nx2)then
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i,j-1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,3)
      if(i1.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      np2=ipuzns(i+1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,4)
      if(i2.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      endif
      return
      endif
C
      if(i.eq.nx1.and.j.eq.nx2)then
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i,j-1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,3)
      if(i1.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      np2=ipuzns(i-1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,2)
      if(i4.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      endif
      return
      endif
C
C  Borders
C
      if(i.eq.1)then
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i,j-1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,3)
      if(i1.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      np2=ipuzns(i+1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,4)
      if(i2.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      np2=ipuzns(i,j+1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,1)
      if(i3.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      endif
      return
      endif
C
      if(j.eq.1)then
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i+1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,4)
      if(i2.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      np2=ipuzns(i,j+1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,1)
      if(i3.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      np2=ipuzns(i-1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,2)
      if(i4.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      endif
      return
      endif
C
      if(i.eq.nx1)then
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i,j-1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,3)
      if(i1.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      np2=ipuzns(i,j+1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,1)
      if(i3.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      np2=ipuzns(i-1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,2)
      if(i4.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      endif
      return
      endif
C
      if(j.eq.nx2)then
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i,j-1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,3)
      if(i1.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      np2=ipuzns(i+1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,4)
      if(i2.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      np2=ipuzns(i-1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,2)
      if(i4.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      endif
      return
      endif
C
C  Center
C
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i,j-1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,3)
      if(i1.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      np2=ipuzns(i+1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,4)
      if(i2.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      np2=ipuzns(i,j+1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,1)
      if(i3.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      np2=ipuzns(i-1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,2)
      if(i4.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         endif
      endif
      endif
      return
      end
C
C
C
C
C
C  Final check on edges satisfied... + remove the bad
C
      subroutine remedge(iedges,ibad,nis,ipuzns,nzs)
C
C
      parameter (maxp=257)
      integer nis(maxp),nzs(maxp,4),ipuzns(16,16)
      common/size/nx1,nx2,nxmax,nx3,nx4,nx5,nx6
C
C
C  Center
C
      do i=2,nx3
      do j=2,nx4
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i,j-1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,3)
      if(i1.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         ipuzns(i,j)=0
         endif
      endif
      np2=ipuzns(i+1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,4)
      if(i2.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         ipuzns(i,j)=0
         endif
      endif
      np2=ipuzns(i,j+1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,1)
      if(i3.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         ipuzns(i,j)=0
         endif
      endif
      np2=ipuzns(i-1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,2)
      if(i4.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         ipuzns(i,j)=0
         endif
      endif
      endif
      enddo
      enddo
C
C  Corners
C
      i=1
      j=1
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i+1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,4)
      if(i2.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         ipuzns(i,j)=0
         endif
      endif
      np2=ipuzns(i,j+1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,1)
      if(i3.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         ipuzns(i,j)=0
         endif
      endif
      endif
C
      i=nx1
      j=1
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i,j+1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,1)
      if(i3.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         ipuzns(i,j)=0
         endif
      endif
      np2=ipuzns(i-1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,2)
      if(i4.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         ipuzns(i,j)=0
         endif
      endif
      endif
C
      i=1
      j=nx2
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i,j-1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,3)
      if(i1.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         ipuzns(i,j)=0
         endif
      endif
      np2=ipuzns(i+1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,4)
      if(i2.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         ipuzns(i,j)=0
         endif
      endif
      endif
C
      i=nx1
      j=nx2
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i,j-1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,3)
      if(i1.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         ipuzns(i,j)=0
         endif
      endif
      np2=ipuzns(i-1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,2)
      if(i4.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         ipuzns(i,j)=0
         endif
      endif
      endif
C
C  Borders
C
      i=1
      do j=2,nx4
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i,j-1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,3)
      if(i1.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         ipuzns(i,j)=0
         endif
      endif
      np2=ipuzns(i+1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,4)
      if(i2.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         ipuzns(i,j)=0
         endif
      endif
      np2=ipuzns(i,j+1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,1)
      if(i3.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         ipuzns(i,j)=0
         endif
      endif
      endif
      enddo
C
      j=1
      do i=2,nx3
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i+1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,4)
      if(i2.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         ipuzns(i,j)=0
         endif
      endif
      np2=ipuzns(i,j+1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,1)
      if(i3.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         ipuzns(i,j)=0
         endif
      endif
      np2=ipuzns(i-1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,2)
      if(i4.eq.j3)then
         iedges=iedges+1
         else
         ipuzns(i,j)=0
         ibad=ibad+1
         endif
      endif
      endif
      enddo
C
      i=nx1
      do j=2,nx4
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i,j-1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,3)
      if(i1.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         ipuzns(i,j)=0
         endif
      endif
      np2=ipuzns(i,j+1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,1)
      if(i3.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         ipuzns(i,j)=0
         endif
      endif
      np2=ipuzns(i-1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,2)
      if(i4.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         ipuzns(i,j)=0
         endif
      endif
      endif
      enddo
C
      j=nx2
      do i=2,nx3
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i,j-1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,3)
      if(i1.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         ipuzns(i,j)=0
         endif
      endif
      np2=ipuzns(i+1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,4)
      if(i2.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         ipuzns(i,j)=0
         endif
      endif
      np2=ipuzns(i-1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,2)
      if(i4.eq.j3)then
         iedges=iedges+1
         else
         ibad=ibad+1
         ipuzns(i,j)=0
         endif
      endif
      endif
      enddo
      iedges=iedges/2
      ibad=ibad/2
      return
      end
C
C
C
C
C  Check on edges satisfied for the last placed piece...
C
      subroutine nedges(i,j,ibad,nzs)
C
C
C
C
      parameter (maxp=257)
      integer nis(maxp),nzs(maxp,4),ipuzns(16,16)
      common/puz/nis,ipuzns
      common/size/nx1,nx2,nxmax,nx3,nx4,nx5,nx6
C
C  Center
C
      if(i.ne.1.and.i.ne.nx1.and.j.ne.1.and.j.ne.nx2)then
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i,j-1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,3)
      if(i1.ne.j3)ibad=ibad+1
      endif
      np2=ipuzns(i+1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,4)
      if(i2.ne.j3)ibad=ibad+1
      endif
      np2=ipuzns(i,j+1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,1)
      if(i3.ne.j3)ibad=ibad+1
      endif
      np2=ipuzns(i-1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,2)
      if(i4.ne.j3)ibad=ibad+1
      endif
      endif
      return
      endif
C
C
C
C  Corners
C
      if(i.eq.1.and.j.eq.1)then
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i+1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,4)
      if(i2.ne.j3)ibad=ibad+1
      endif
      np2=ipuzns(i,j+1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,1)
      if(i3.ne.j3)ibad=ibad+1
      endif
      endif
      return
      endif
C
      if(i.eq.nx1.and.j.eq.1)then
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i,j+1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,1)
      if(i3.ne.j3)ibad=ibad+1
      endif
      np2=ipuzns(i-1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,2)
      if(i4.ne.j3)ibad=ibad+1
      endif
      endif
      return
      endif
C
      if(i.eq.1.and.j.eq.nx2)then
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i,j-1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,3)
      if(i1.ne.j3)ibad=ibad+1
      endif
      np2=ipuzns(i+1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,4)
      if(i2.ne.j3)ibad=ibad+1
      endif
      endif
      return
      endif
C
      if(i.eq.nx1.and.j.eq.nx2)then
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i,j-1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,3)
      if(i1.ne.j3)ibad=ibad+1
      endif
      np2=ipuzns(i-1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,2)
      if(i4.ne.j3)ibad=ibad+1
      endif
      endif
      return
      endif
C
C  Borders
C
      if(i.eq.1)then
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i,j-1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,3)
      if(i1.ne.j3)ibad=ibad+1
      endif
      np2=ipuzns(i+1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,4)
      if(i2.ne.j3)ibad=ibad+1
      endif
      np2=ipuzns(i,j+1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,1)
      if(i3.ne.j3)ibad=ibad+1
      endif
      endif
      return
      endif
C
      if(j.eq.1)then
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i+1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,4)
      if(i2.ne.j3)ibad=ibad+1
      endif
      np2=ipuzns(i,j+1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,1)
      if(i3.ne.j3)ibad=ibad+1
      endif
      np2=ipuzns(i-1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,2)
      if(i4.ne.j3)ibad=ibad+1
      endif
      endif
      return
      endif
C
      if(i.eq.nx1)then
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i,j-1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,3)
      if(i1.ne.j3)ibad=ibad+1
      endif
      np2=ipuzns(i,j+1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,1)
      if(i3.ne.j3)ibad=ibad+1
      endif
      np2=ipuzns(i-1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,2)
      if(i4.ne.j3)ibad=ibad+1
      endif
      endif
      return
      endif
C
      if(j.eq.nx2)then
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i,j-1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,3)
      if(i1.ne.j3)ibad=ibad+1
      endif
      np2=ipuzns(i+1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,4)
      if(i2.ne.j3)ibad=ibad+1
      endif
      np2=ipuzns(i-1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,2)
      if(i4.ne.j3)ibad=ibad+1
      endif
      endif
      return
      endif
C
      return
      end
C
C
C
C
C
C ------------------------------------------------------------
C
C
C  Applying rotation
C
      subroutine rotb(npz,nrot,np,nz)
      parameter (maxp=257)
      integer np(maxp,4),nz(maxp,4)
C
C  no rotation
C
      if(nrot.eq.0)then
      nz(npz,1)=np(npz,1)
      nz(npz,2)=np(npz,2)
      nz(npz,3)=np(npz,3)
      nz(npz,4)=np(npz,4)
      endif
C
C  rotation 90
C
      if(nrot.eq.1)then
      nz(npz,1)=np(npz,4)
      nz(npz,2)=np(npz,1)
      nz(npz,3)=np(npz,2)
      nz(npz,4)=np(npz,3)
      endif
C
C  rotation 180
C
      if(nrot.eq.2)then
      nz(npz,1)=np(npz,3)
      nz(npz,2)=np(npz,4)
      nz(npz,3)=np(npz,1)
      nz(npz,4)=np(npz,2)
      endif
C
C  rotation 270
C
      if(nrot.eq.3)then
      nz(npz,1)=np(npz,2)
      nz(npz,2)=np(npz,3)
      nz(npz,3)=np(npz,4)
      nz(npz,4)=np(npz,1)
      endif
      return
      end
C
C
C
C
C
C  check for ibad on a couple of neighbouring pieces...
C
      subroutine edges2(ii1,jj1,ii2,jj2,ibad,nzs)
C
C
      parameter (maxp=257)
      integer nis(maxp),nzs(maxp,4),ipuzns(16,16)
      common/puz/nis,ipuzns
      common/size/nx1,nx2,nxmax,nx3,nx4,nx5,nx6
C
C  Center
C
      if(ii1.ne.1.and.jj1.ne.1.and.ii1.ne.nx1.and.jj1.ne.nx2)then
      if(ii1.eq.ii2)then
      i=ii1
      jj3=jj1
      jj4=jj2
      if(jj2.lt.jj1)then
      jj3=jj2
      jj4=jj1
      endif
      do j=jj3,jj4
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      if(j.ne.jj4)then
      np2=ipuzns(i,j-1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,3)
      if(i1.ne.j3)ibad=ibad+1
      endif
      endif
      np2=ipuzns(i+1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,4)
      if(i2.ne.j3)ibad=ibad+1
      endif
      np2=ipuzns(i,j+1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,1)
      if(i3.ne.j3)ibad=ibad+1
      endif
      np2=ipuzns(i-1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,2)
      if(i4.ne.j3)ibad=ibad+1
      endif
      endif
      enddo
      return
      endif
C
C
C  Center
C
      if(jj1.eq.jj2)then
      j=jj1
      ii3=ii1
      ii4=ii2
      if(ii2.lt.ii1)then
      ii3=ii2
      ii4=ii1
      endif
      do i=ii3,ii4
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i,j-1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,3)
      if(i1.ne.j3)ibad=ibad+1
      endif
      np2=ipuzns(i+1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,4)
      if(i2.ne.j3)ibad=ibad+1
      endif
      np2=ipuzns(i,j+1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,1)
      if(i3.ne.j3)ibad=ibad+1
      endif
      if(i.ne.ii4)then
      np2=ipuzns(i-1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,2)
      if(i4.ne.j3)ibad=ibad+1
      endif
      endif
      endif
      enddo
      return
      endif
C
      endif
C
C
C  Borders
C
      if(ii1.eq.1.and.ii2.eq.1)then
      i=1
      jj3=jj1
      jj4=jj2
      if(jj2.lt.jj1)then
      jj3=jj2
      jj4=jj1
      endif
      do j=jj3,jj4
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i,j-1)
        if(j.ne.jj4)then
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,3)
      if(i1.ne.j3)ibad=ibad+1
      endif
        endif
      np2=ipuzns(i+1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,4)
      if(i2.ne.j3)ibad=ibad+1
      endif
      np2=ipuzns(i,j+1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,1)
      if(i3.ne.j3)ibad=ibad+1
      endif
      endif
      enddo
      return
      endif
C
      if(jj1.eq.1.and.jj2.eq.1)then
      ii3=ii1
      ii4=ii2
      if(ii2.lt.ii1)then
      ii3=ii2
      ii4=ii1
      endif
      j=1
      do i=ii3,ii4
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i+1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,4)
      if(i2.ne.j3)ibad=ibad+1
      endif
      np2=ipuzns(i,j+1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,1)
      if(i3.ne.j3)ibad=ibad+1
      endif
      if(i.ne.ii4)then
      np2=ipuzns(i-1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,2)
      if(i4.ne.j3)ibad=ibad+1
      endif
      endif
      endif
      enddo
      return
      endif
C
      if(ii1.eq.nx1.and.ii2.eq.nx1)then
      i=nx1
      jj3=jj1
      jj4=jj2
      if(jj2.lt.jj1)then
      jj3=jj2
      jj4=jj1
      endif
      do j=jj3,jj4
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      if(j.ne.jj4)then
      np2=ipuzns(i,j-1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,3)
      if(i1.ne.j3)ibad=ibad+1
      endif
      endif
      np2=ipuzns(i,j+1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,1)
      if(i3.ne.j3)ibad=ibad+1
      endif
      np2=ipuzns(i-1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,2)
      if(i4.ne.j3)ibad=ibad+1
      endif
      endif
      enddo
      return
      endif
C
      if(jj1.eq.nx2.and.jj2.eq.nx2)then
      ii3=ii1
      ii4=ii2
      if(ii2.lt.ii1)then
      ii3=ii2
      ii4=ii1
      endif
      j=nx2
      do i=ii3,ii4
      np1=ipuzns(i,j)
      if(np1.ne.0)then
      npz1=nis(np1)
      i1=nzs(npz1,1)
      i2=nzs(npz1,2)
      i3=nzs(npz1,3)
      i4=nzs(npz1,4)
      np2=ipuzns(i,j-1)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,3)
      if(i1.ne.j3)ibad=ibad+1
      endif
      np2=ipuzns(i+1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,4)
      if(i2.ne.j3)ibad=ibad+1
      endif
      if(i.ne.ii4)then
      np2=ipuzns(i-1,j)
      if(np2.ne.0)then
      npz2=nis(np2)
      j3=nzs(npz2,2)
      if(i4.ne.j3)ibad=ibad+1
      endif
      endif
      endif
      enddo
      endif
C
      return
      end
C
C
C
